//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/Color3DLUT_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/Color3DLUT.glsl by quoteFile.
//
const char* Color3DLUT_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"//\n"
"//  3D LUT lookup.  The outScale and outOffset re-expand the output of\n"
"//  the 3D LUT to its normal range. The out scaling is required\n"
"//  because the input 3D LUT may be normalized if it was stored as an\n"
"//  integral type.\n"
"//\n"
"//  Texel values are at *centers* so we need to account for that when\n"
"//  looking up value.\n"
"//\n"
"//  we do trilinear ourselves here, and not use gl's 3d sampling\n"
"//\n"
"\n"
"vec4 Color3DLUT(const in vec4 P,\n"
"                const in sampler3D RGB_sampler,\n"
"                const in vec3 sizeMinusOne,\n"
"                const in vec3 inScale,\n"
"                const in vec3 inOffset,\n"
"                const in vec3 outScale,\n"
"                const in vec3 outOffset)\n"
"{\n"
"    \n"
"    vec3 iP = clamp(P.rgb, vec3(0.0), vec3(1.0)) * sizeMinusOne;  //  Index in lattice of color\n"
"    vec3 p0 = floor(iP);                //  Floor index lattice location\n"
"    vec3 p1 = p0 + vec3(1.0, 1.0, 1.0); //  Far (diag) lattice point\n"
"    vec3 u  = iP - p0;                  //  Local cell parameter\n"
"\n"
"    vec3 n0 = p0 * inScale + inOffset;  //  Normalized texture coords\n"
"    vec3 n1 = p1 * inScale + inOffset;  //  NOTE: transform to texel center\n"
"\n"
"    //\n"
"    // 1st face\n"
"    //\n"
"\n"
"    vec4 c0 = mix(texture(RGB_sampler, n0),\n"
"                  texture(RGB_sampler, vec3(n1.x, n0.y, n0.z)),\n"
"                  u.x);\n"
"\n"
"    vec4 c1 = mix(texture(RGB_sampler, vec3(n0.x, n1.y, n0.z)),\n"
"                  texture(RGB_sampler, vec3(n1.x, n1.y, n0.z)),\n"
"                  u.x);\n"
"\n"
"    vec4 ca = mix(c0, c1, u.y);\n"
"\n"
"    //\n"
"    // 2nd face\n"
"    //\n"
"\n"
"    vec4 c2 = mix(texture(RGB_sampler, vec3(n0.x, n0.y, n1.z)),\n"
"                  texture(RGB_sampler, vec3(n1.x, n0.y, n1.z)),\n"
"                  u.x);\n"
"\n"
"    vec4 c3 = mix(texture(RGB_sampler, vec3(n0.x, n1.y, n1.z)),\n"
"                  texture(RGB_sampler, n1),\n"
"                  u.x);\n"
"\n"
"    vec4 cb = mix(c2, c3, u.y);\n"
"\n"
"    //\n"
"    //  Interp face colors\n"
"    //\n"
"\n"
"    vec4 c = mix(ca, cb, u.z);\n"
"    \n"
"    //\n"
"    //  Apply output transform and return\n"
"    //\n"
"\n"
"    return vec4(c.rgb * outScale + outOffset, P.a);\n"
"}\n"
"\n"
;
