//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/InlineAdaptiveBoxResize_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/InlineAdaptiveBoxResize.glsl by quoteFile.
//
const char* InlineAdaptiveBoxResize_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"#if __VERSION__ < 150\n"
"vec4 InlineAdaptiveBoxResize (const in inputImage in0)\n"
"{\n"
"    return in0();\n"
"}\n"
"#else\n"
"\n"
"vec4 InlineAdaptiveBoxResize (const in inputImage in0)\n"
"{\n"
"    vec2 st = in0.st;\n"
"    vec2 d = fwidth(st);\n"
"    float l = max(d.x, d.y);\n"
"    const float pi = 3.1415926;\n"
"    const float pi2 = pi * pi;\n"
"\n"
"//    const float onesixth = 1.0 / 6;\n"
"    if (l <= 0.5) \n"
"    {\n"
"        const float B = 1.0 / 3;\n"
"        const float C = B;\n"
"        //mitchell\n"
"        //just for visualization purposes\n"
"        if (length(st) < 30.0) \n"
"        {\n"
"            vec4 c = vec4(clamp(1 - l * 4.0, 0.0, 1.0),\n"
"                          clamp(1 - l * 3.0, 0.0, 1.0),\n"
"                          clamp(1 - l * 2.0, 0.0, 1.0), \n"
"                          1.0);\n"
"            return c;\n"
"        }\n"
"\n"
"        // [-2, 2] kernel\n"
"        float totalweight = 0;\n"
"        float weight = 0;\n"
"        vec4 sum = vec4(0.0);\n"
"        float step = 0.5;\n"
"        for (float i = -1.5; i <= 1.5; i+= step) {\n"
"            float lx = 0;\n"
"            float absi = abs(i);\n"
"            if (absi < 2) {\n"
"                if (absi < 1)\n"
"                    lx = (12 - 9 * B - 6 * C) * absi * absi * absi \n"
"                        + (-18 + 12 * B + 6 * C) * absi * absi\n"
"                        + 6 - 2 * B;\n"
"                else\n"
"                    lx = (-B - 6 * C) * absi * absi * absi \n"
"                        + (6 * B + 30 * C) * absi * absi\n"
"                        + (-12 * B - 48 * C) * absi\n"
"                        + 8 * B + 24 * C;\n"
"            }\n"
"            for (float j = -1.5; j <= 1.5; j+= step) {\n"
"                float ly = 0;\n"
"                float absj = abs(j);\n"
"                if (absj < 2) {\n"
"                    if (absj < 1)\n"
"                        ly = (12 - 9 * B - 6 * C) * absj * absj * absj \n"
"                            + (-18 + 12 * B + 6 * C) * absj * absj\n"
"                            + 6 - 2 * B;\n"
"                    else\n"
"                        ly = (-B - 6 * C) * absj * absj * absj \n"
"                            + (6 * B + 30 * C) * absj * absj\n"
"                            + (-12 * B - 48 * C) * absj\n"
"                            + 8 * B + 24 * C;   \n"
"                }\n"
"                weight = lx * ly;\n"
"                vec4 c = in0(vec2(j, i));               \n"
"                sum = sum + c * weight;\n"
"                totalweight += weight; \n"
"\n"
"            }\n"
"        }\n"
"        return sum / totalweight;            \n"
"\n"
"    }\n"
"    if (l >= 2.0)\n"
"    {\n"
"        vec4 c = vec4(0.0);\n"
"        //just for visualization purposes\n"
"        if (length(st) < 30.0) \n"
"        {\n"
"            vec4 c = vec4(clamp(l - 4.0, 0.0, 1.0),\n"
"                          clamp(l - 3.0, 0.0, 1.0),\n"
"                          clamp(l - 2.0, 0.0, 1.0), \n"
"                          1.0);\n"
"            return c;\n"
"        }\n"
"\n"
"        float halfl = l * 0.5;\n"
"        float step = 1.0 / l; //step is defined as the inverse of\n"
"        //the number of gaps for the filter\n"
"        //kernel size \n"
"        float totalweight = 0;\n"
"        float weight = 0;\n"
"        vec4 sum = vec4(0.0);\n"
"        float a = int(halfl);\n"
"        float ainverse = 1.0 / a;\n"
"\n"
"        for (float i = -halfl + step; i < halfl; i+= step) {\n"
"            float lx = 1; \n"
"            if (i != 0)\n"
"                lx = a * sin (pi * i) * sin (pi * i * ainverse) / pi2 / i / i;\n"
"            for (float j = -halfl + step; j < halfl; j+=step) {\n"
"                float ly = 1;\n"
"                if (j != 0)\n"
"                    ly = a * sin (pi * j) * sin (pi * j * ainverse) / pi2 / j / j;\n"
"                weight = lx * ly;\n"
"                vec4 c = in0(vec2(j, i));               \n"
"                sum = sum + c * weight;\n"
"                totalweight += weight; \n"
"\n"
"            }\n"
"        }\n"
"        return sum / totalweight;\n"
"    }\n"
"    //todo\n"
"    return in0();\n"
"}\n"
"\n"
"#endif\n"
;
