//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/ResizeDownSampleDerivative_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/ResizeDownSampleDerivative.glsl by quoteFile.
//
const char* ResizeDownSampleDerivative_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"vec4 ResizeDownSampleDerivative( const in inputImage in0,\n"
"                                 const in outputImage win )\n"
"{\n"
"    // Compute the sum of absolute derivates of texcoords in x/y.\n"
"    vec2 absDer = fwidth( in0.st );\n"
"\n"
"    // Get the max out of x/y abs derivatives.\n"
"    float maxAbsDer = max( absDer.x, absDer.y );\n"
"\n"
"    // We mimic a GL_LINEAR_MIPMAP_NEAREST implementation.\n"
"    // We divide by 2 because the kernel is ~symmetrical (we assume that the\n"
"    // center is neglictable)\n"
"    int KERNEL_SIZE = int( maxAbsDer / 2.0 );\n"
"\n"
"    // Clamp the kernel in a \"reasonable\" range, yet equivalent to a mipmap \n"
"    // level of >5.\n"
"    // \n"
"    // KERNEL_SIZE == 0  --> 1x1 (no-op, mipmap level 0)\n"
"    // KERNEL_SIZE == 1  --> 3x3 (> mipmap level 1)\n"
"    // KERNEL_SIZE == 2  --> 5x5 (> mipmap level 2)\n"
"    // KERNEL_SIZE == 3  --> 7x7\n"
"    // KERNEL_SIZE == 4  --> 9x9 (> mipmap level 3)\n"
"    // KERNEL_SIZE == 5  --> 11x11 \n"
"    // KERNEL_SIZE == 6  --> 13x13 \n"
"    // KERNEL_SIZE == 7  --> 15x15 \n"
"    // KERNEL_SIZE == 8  --> 17x17 (> mipmap level 4)\n"
"    // KERNEL_SIZE == 9  --> 19x19 \n"
"    // KERNEL_SIZE == 10 --> 21x21 \n"
"    // KERNEL_SIZE == 11 --> 23x23 \n"
"    // KERNEL_SIZE == 12 --> 25x25 \n"
"    // KERNEL_SIZE == 13 --> 27x27 \n"
"    // KERNEL_SIZE == 14 --> 29x29 \n"
"    // KERNEL_SIZE == 15 --> 31x31 \n"
"    // KERNEL_SIZE == 16 --> 33x33 (> mipmap level 5)\n"
"\n"
"    if ( KERNEL_SIZE < 0 )\n"
"    {\n"
"        KERNEL_SIZE = 0;\n"
"    }\n"
"    else if ( KERNEL_SIZE > 16 )\n"
"    {\n"
"        KERNEL_SIZE = 16;\n"
"    }\n"
"\n"
"    // cumulate all the sample colors\n"
"    vec4 averageColor=vec4(0.0,0.0,0.0,0.0);\n"
"    for ( int x = -KERNEL_SIZE ; x <= KERNEL_SIZE ; x++ )\n"
"    {\n"
"        for ( int y = -KERNEL_SIZE ; y <= KERNEL_SIZE ; y++ )\n"
"        {\n"
"            averageColor+= in0( vec2 ( x , y ) );\n"
"        }\n"
"    }\n"
"\n"
"    // divide by the number of samples\n"
"    float nbSamples = float( ( KERNEL_SIZE * 2 + 1 )* ( KERNEL_SIZE * 2 + 1 ) );\n"
"    averageColor /= vec4(nbSamples);\n"
"\n"
"    return averageColor;\n"
"}\n"
"\n"
;
