//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/SourceBGRAUncrop_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/SourceBGRAUncrop.glsl by quoteFile.
//
const char* SourceBGRAUncrop_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"//\n"
"//  Look up BGRA value from rect sampler. \n"
"//\n"
"//  This is used either in the case that the FB is already in BGRA\n"
"//  format *or* we used the BGRA fast path to load the image (and lied\n"
"//  about the layout). \n"
"//\n"
"//  Its still not clear to me if we should just allow the driver to do\n"
"//  swizzling when uploading instead of doing during render. I suppose\n"
"//  it depends on how many fragment pixels are evaluated.\n"
"//\n"
"vec4 SourceBGRAUncrop (const in sampler2DRect RGBA_sampler,\n"
"                       const in vec2 ST,\n"
"                       const in vec2 offset,\n"
"                       const in vec2 samplerSize,\n"
"                       const in vec2 uncropOrigin,\n"
"                       const in vec2 uncropDimension,\n"
"                       const in float orientation)\n"
"{\n"
"    vec2 texCoord = ST + offset;\n"
"    \n"
"    if (orientation == 1.0) // tl\n"
"    {\n"
"        texCoord.y = samplerSize.y - texCoord.y;\n"
"    }\n"
"    else if (orientation == 2.0) // br\n"
"    {\n"
"        texCoord.x = samplerSize.x - texCoord.x;\n"
"    }\n"
"    else if (orientation == 3.0) // tr\n"
"    {\n"
"        texCoord.x = samplerSize.x - texCoord.x;\n"
"        texCoord.y = samplerSize.y - texCoord.y;\n"
"    }\n"
"\n"
"    // apply transformation on the texCoord to obtain the proper texCoord if necessary\n"
"    if (uncropOrigin.x != 0.0 || uncropOrigin.y != 0.0 ||\n"
"        uncropDimension.x != samplerSize.x || uncropDimension.y != samplerSize.y)\n"
"    {\n"
"        float x = texCoord.x / samplerSize.x;\n"
"        float y = texCoord.y / samplerSize.y;\n"
"        float newx = uncropDimension.x * x - uncropOrigin.x; \n"
"        float newy = uncropDimension.y * y - uncropOrigin.y;								  \n"
"        vec2 adjustedTexCoord = vec2(newx, newy);\n"
"        if (adjustedTexCoord.x < 0.0 || adjustedTexCoord.y < 0.0 || \n"
"            adjustedTexCoord.x >= samplerSize.x || adjustedTexCoord.y >= samplerSize.y)\n"
"            return vec4(0.0);\n"
"        return texture(RGBA_sampler, adjustedTexCoord).bgra;\n"
"    }\n"
"\n"
"    return texture(RGBA_sampler, texCoord).bgra;// NOTE: swizzle here\n"
"}\n"
"\n"
;
