//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/SourceBGRA_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/SourceBGRA.glsl by quoteFile.
//
const char* SourceBGRA_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"//\n"
"//  Look up BGRA value from rect sampler. \n"
"//\n"
"//  This is used either in the case that the FB is already in BGRA\n"
"//  format *or* we used the BGRA fast path to load the image (and lied\n"
"//  about the layout). \n"
"//\n"
"//  Its still not clear to me if we should just allow the driver to do\n"
"//  swizzling when uploading instead of doing during render. I suppose\n"
"//  it depends on how many fragment pixels are evaluated.\n"
"//\n"
"\n"
"//  NOTE if we are in gl 3.0+ we can do textureSize on the sampler and\n"
"//  will not need to pass it in. this is just for compatiblity\n"
"\n"
"vec4 SourceBGRA (const in sampler2DRect RGBA_sampler,\n"
"                 const in vec2 ST,\n"
"                 const in vec2 offset,\n"
"                 const in vec2 RGBA_samplerSize,\n"
"                 const in float orientation)\n"
"{\n"
"    vec2 t = ST + offset;\n"
"    if (t.x < 0.0 || t.y < 0.0 || t.x >= RGBA_samplerSize.x || t.y >= RGBA_samplerSize.y)\n"
"	return vec4(0.0); // black pixels with alpha 0\n"
"    \n"
"    if (orientation == 1.0) // tl\n"
"    {\n"
"        t.y = RGBA_samplerSize.y - t.y;\n"
"    }\n"
"    else if (orientation == 2.0) // br\n"
"    {\n"
"        t.x = RGBA_samplerSize.x - t.x;\n"
"    }\n"
"    else if (orientation == 3.0) // tr\n"
"    {\n"
"        t.x = RGBA_samplerSize.x - t.x;\n"
"        t.y = RGBA_samplerSize.y - t.y;\n"
"    }\n"
"    \n"
"    return texture(RGBA_sampler, t).bgra; // NOTE: swizzle here\n"
"}\n"
"\n"
;
