//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/SourcePlanarRGBUncrop_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/SourcePlanarRGBUncrop.glsl by quoteFile.
//
const char* SourcePlanarRGBUncrop_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"//\n"
"// Assemble RGBA from R G B planes.\n"
"//\n"
"// G is assumed to have the \"master\" coordinates. I.e. G will always\n"
"// have the highest resolution (but may be the same as R and B)\n"
"//\n"
"// TODO make it work with other resolution R and B\n"
"//\n"
"\n"
"vec4 SourcePlanarRGBUncrop(const in sampler2DRect R_sampler,\n"
"                           const in sampler2DRect G_sampler,\n"
"                           const in sampler2DRect B_sampler,\n"
"                           const in vec2 ST,\n"
"                           const in vec2 offset,\n"
"                           const in vec2 samplerSize,\n"
"                           const in vec2 uncropOrigin,\n"
"                           const in vec2 uncropDimension,\n"
"                           const in float orientation)\n"
"{\n"
"    vec2 texCoord = ST + offset;\n"
"    \n"
"    if (orientation == 1.0) // tl\n"
"    {\n"
"        texCoord.y = samplerSize.y - texCoord.y;\n"
"    }\n"
"    else if (orientation == 2.0) // br\n"
"    {\n"
"        texCoord.x = samplerSize.x - texCoord.x;\n"
"    }\n"
"    else if (orientation == 3.0) // tr\n"
"    {\n"
"        texCoord.x = samplerSize.x - texCoord.x;\n"
"        texCoord.y = samplerSize.y - texCoord.y;\n"
"    }\n"
"    \n"
"    // apply transformation on the texCoord to obtain the proper\n"
"    // texCoord if necessary\n"
"    if (uncropOrigin.x != 0.0 || uncropOrigin.y != 0.0 ||\n"
"        uncropDimension.x != samplerSize.x || uncropDimension.y != samplerSize.y)\n"
"    {\n"
"        float x = texCoord.x / samplerSize.x;\n"
"        float y = texCoord.y / samplerSize.y;\n"
"        float newx = uncropDimension.x * x - uncropOrigin.x; \n"
"        float newy = uncropDimension.y * y - uncropOrigin.y;								  \n"
"        vec2 adjustedTexCoord = vec2(newx, newy);\n"
"        if (adjustedTexCoord.x < 0.0 || adjustedTexCoord.y < 0.0 || \n"
"            adjustedTexCoord.x >= samplerSize.x || adjustedTexCoord.y >= samplerSize.y)\n"
"            return vec4(0.0);\n"
"\n"
"        return vec4( texture(R_sampler, adjustedTexCoord).r,\n"
"                     texture(G_sampler, adjustedTexCoord).r,\n"
"                     texture(B_sampler, adjustedTexCoord).r,\n"
"                     1.0 );\n"
"    }\n"
"    return vec4( texture(R_sampler, texCoord).r,\n"
"                 texture(G_sampler, texCoord).r,\n"
"                 texture(B_sampler, texCoord).r,\n"
"                 1.0 );\n"
"}\n"
;
