//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/SourcePlanarYAUncrop_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/SourcePlanarYAUncrop.glsl by quoteFile.
//
const char* SourcePlanarYAUncrop_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"//\n"
"//  Look up Y and A values from rect samplers.\n"
"//  Two channel image lookup\n"
"//\n"
"\n"
"//  NOTE if we are in gl 3.0+ we can do textureSize on the sampler and\n"
"//  will not need to pass it in. this is just for compatiblity\n"
"\n"
"vec4 SourcePlanarYAUncrop (const in sampler2DRect Y_sampler, \n"
"                           const in sampler2DRect A_sampler,\n"
"                           const in vec2 ST,\n"
"                           const in vec2 offset,\n"
"                           const in vec2 Y_samplerSize,\n"
"                           const in vec2 uncropOrigin,\n"
"                           const in vec2 uncropDimension,\n"
"                           const in float orientation)\n"
"{\n"
"    vec2 st = ST + offset;\n"
"    \n"
"    if (orientation == 1.0) // tl\n"
"    {\n"
"        st.y = Y_samplerSize.y - st.y;\n"
"    }\n"
"    else if (orientation == 2.0) // br\n"
"    {\n"
"        st.x = Y_samplerSize.x - st.x;\n"
"    }\n"
"    else if (orientation == 3.0) // tr\n"
"    {\n"
"        st.x = Y_samplerSize.x - st.x;\n"
"        st.y = Y_samplerSize.y - st.y;\n"
"    }\n"
"    \n"
"    if (uncropOrigin.x != 0.0 || uncropOrigin.y != 0.0 ||\n"
"        uncropDimension.x != Y_samplerSize.x || uncropDimension.y != Y_samplerSize.y)\n"
"    {\n"
"        float x = st.x / Y_samplerSize.x;\n"
"        float y = st.y / Y_samplerSize.y;\n"
"        float newx = uncropDimension.x * x - uncropOrigin.x; \n"
"        float newy = uncropDimension.y * y - uncropOrigin.y;								  \n"
"        vec2 adjustedTexCoord = vec2(newx, newy);\n"
"        if (adjustedTexCoord.x < 0.0 || adjustedTexCoord.y < 0.0 || \n"
"            adjustedTexCoord.x >= Y_samplerSize.x || adjustedTexCoord.y >= Y_samplerSize.y)\n"
"            return vec4(0.0); // black pixels with alpha 0\n"
"\n"
"        return vec4(texture(Y_sampler, adjustedTexCoord).rrr, // NOTE: swizzle here\n"
"                    texture(A_sampler, adjustedTexCoord).r); \n"
"    }\n"
"    return vec4(texture(Y_sampler, st).rrr, // NOTE: swizzle here\n"
"                texture(A_sampler, st).r); \n"
"}\n"
"\n"
;
