//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/SourceYAUncrop_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/SourceYAUncrop.glsl by quoteFile.
//
const char* SourceYAUncrop_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"//\n"
"//  Look up Y and A value from rect sampler.\n"
"//  Two channel image lookup\n"
"//\n"
"\n"
"//  NOTE if we are in gl 3.0+ we can do textureSize on the sampler and\n"
"//  will not need to pass it in. this is just for compatiblity\n"
"vec4 SourceYAUncrop (const in sampler2DRect YA_sampler,\n"
"                     const in vec2 ST,\n"
"                     const in vec2 offset,\n"
"                     const in vec2 YA_samplerSize,\n"
"                     const in vec2 uncropOrigin,\n"
"                     const in vec2 uncropDimension,\n"
"                     const in float orientation)\n"
"{\n"
"    vec2 t = ST + offset;\n"
"\n"
"    if (orientation == 1.0) // tl\n"
"    {\n"
"        t.y = YA_samplerSize.y - t.y;\n"
"    }\n"
"    else if (orientation == 2.0) // br\n"
"    {\n"
"        t.x = YA_samplerSize.x - t.x;\n"
"    }\n"
"    else if (orientation == 3.0) // tr\n"
"    {\n"
"        t.x = YA_samplerSize.x - t.x;\n"
"        t.y = YA_samplerSize.y - t.y;\n"
"    }\n"
"\n"
"    if (uncropOrigin.x != 0.0 ||\n"
"        uncropOrigin.y != 0.0 ||\n"
"        uncropDimension.x != YA_samplerSize.x || \n"
"        uncropDimension.y != YA_samplerSize.y)\n"
"    {\n"
"        float x    = t.x / YA_samplerSize.x;\n"
"        float y    = t.y / YA_samplerSize.y;\n"
"        float newx = uncropDimension.x * x - uncropOrigin.x; \n"
"        float newy = uncropDimension.y * y - uncropOrigin.y;								  \n"
"        vec2  nt   = vec2(newx, newy);\n"
"\n"
"        if (nt.x < 0.0 || \n"
"            nt.y < 0.0 || \n"
"            nt.x >= YA_samplerSize.x || \n"
"            nt.y >= YA_samplerSize.y)\n"
"        {\n"
"            return vec4(0.0); // black pixels with alpha 0\n"
"        }\n"
"        else\n"
"        {\n"
"            return texture(YA_sampler, nt).rrra;\n"
"        }\n"
"    }\n"
"\n"
"    return texture(YA_sampler, t).rrra; // NOTE: swizzle here\n"
"}\n"
"\n"
;
