//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QAbstractItemModelType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QSizeType.h>
#include <MuQt6/QObjectType.h>
#include <MuQt6/QEventType.h>
#include <MuQt6/QMimeDataType.h>
#include <MuQt6/QModelIndexType.h>
#include <MuQt6/QVariantType.h>
#include <MuQt6/QTimerEventType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QAbstractItemModel::~MuQt_QAbstractItemModel()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QAbstractItemModel::MuQt_QAbstractItemModel(Pointer muobj,
                                                     const CallEnvironment* ce,
                                                     QObject* parent)
        : QAbstractItemModel(parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QAbstractItemModelType>(
            c->internName("qt.QAbstractItemModel"));
    }

    QModelIndex MuQt_QAbstractItemModel::buddy(const QModelIndex& index) const
    {
        if (!_env)
            return QAbstractItemModel::buddy(index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return getqtype<QModelIndexType>(rval._Pointer);
        }
        else
        {
            return QAbstractItemModel::buddy(index);
        }
    }

    bool MuQt_QAbstractItemModel::canDropMimeData(
        const QMimeData* data, Qt::DropAction action, int row, int column,
        const QModelIndex& parent) const
    {
        if (!_env)
            return QAbstractItemModel::canDropMimeData(data, action, row,
                                                       column, parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(6);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeinstance<QMimeDataType>(c, data, "qt.QMimeData"));
            args[2] = Value(int(action));
            args[3] = Value(row);
            args[4] = Value(column);
            args[5] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::canDropMimeData(data, action, row,
                                                       column, parent);
        }
    }

    bool MuQt_QAbstractItemModel::canFetchMore(const QModelIndex& parent) const
    {
        if (!_env)
            return QAbstractItemModel::canFetchMore(parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::canFetchMore(parent);
        }
    }

    bool MuQt_QAbstractItemModel::clearItemData(const QModelIndex& index)
    {
        if (!_env)
            return QAbstractItemModel::clearItemData(index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::clearItemData(index);
        }
    }

    int MuQt_QAbstractItemModel::columnCount(
        const QModelIndex& parent) const // pure virtual
    {
        if (!_env)
            return defaultValue<int>();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[4];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return defaultValue<int>();
        }
    }

    QVariant MuQt_QAbstractItemModel::data(const QModelIndex& index,
                                           int role) const // pure virtual
    {
        if (!_env)
            return defaultValue<QVariant>();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[5];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            args[2] = Value(role);
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return defaultValue<QVariant>();
        }
    }

    bool MuQt_QAbstractItemModel::dropMimeData(const QMimeData* data,
                                               Qt::DropAction action, int row,
                                               int column,
                                               const QModelIndex& parent)
    {
        if (!_env)
            return QAbstractItemModel::dropMimeData(data, action, row, column,
                                                    parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[6];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(6);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeinstance<QMimeDataType>(c, data, "qt.QMimeData"));
            args[2] = Value(int(action));
            args[3] = Value(row);
            args[4] = Value(column);
            args[5] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::dropMimeData(data, action, row, column,
                                                    parent);
        }
    }

    void MuQt_QAbstractItemModel::fetchMore(const QModelIndex& parent)
    {
        if (!_env)
        {
            QAbstractItemModel::fetchMore(parent);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[7];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractItemModel::fetchMore(parent);
        }
    }

    Qt::ItemFlags MuQt_QAbstractItemModel::flags(const QModelIndex& index) const
    {
        if (!_env)
            return QAbstractItemModel::flags(index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[8];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (Qt::ItemFlags)(rval._int);
        }
        else
        {
            return QAbstractItemModel::flags(index);
        }
    }

    bool MuQt_QAbstractItemModel::hasChildren(const QModelIndex& parent) const
    {
        if (!_env)
            return QAbstractItemModel::hasChildren(parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[9];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::hasChildren(parent);
        }
    }

    QVariant MuQt_QAbstractItemModel::headerData(int section,
                                                 Qt::Orientation orientation,
                                                 int role) const
    {
        if (!_env)
            return QAbstractItemModel::headerData(section, orientation, role);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[10];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(section);
            args[2] = Value(int(orientation));
            args[3] = Value(role);
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QAbstractItemModel::headerData(section, orientation, role);
        }
    }

    QModelIndex MuQt_QAbstractItemModel::index(
        int row, int column, const QModelIndex& parent) const // pure virtual
    {
        if (!_env)
            return defaultValue<QModelIndex>();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[11];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(row);
            args[2] = Value(column);
            args[3] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return getqtype<QModelIndexType>(rval._Pointer);
        }
        else
        {
            return defaultValue<QModelIndex>();
        }
    }

    bool MuQt_QAbstractItemModel::insertColumns(int column, int count,
                                                const QModelIndex& parent)
    {
        if (!_env)
            return QAbstractItemModel::insertColumns(column, count, parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[12];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(column);
            args[2] = Value(count);
            args[3] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::insertColumns(column, count, parent);
        }
    }

    bool MuQt_QAbstractItemModel::insertRows(int row, int count,
                                             const QModelIndex& parent)
    {
        if (!_env)
            return QAbstractItemModel::insertRows(row, count, parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[13];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(row);
            args[2] = Value(count);
            args[3] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::insertRows(row, count, parent);
        }
    }

    QModelIndexList MuQt_QAbstractItemModel::match(const QModelIndex& start,
                                                   int role,
                                                   const QVariant& value,
                                                   int hits,
                                                   Qt::MatchFlags flags) const
    {
        if (!_env)
            return QAbstractItemModel::match(start, role, value, hits, flags);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[14];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(6);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, start, "qt.QModelIndex"));
            args[2] = Value(role);
            args[3] = Value(makeqtype<QVariantType>(c, value, "qt.QVariant"));
            args[4] = Value(hits);
            args[5] = Value(int(flags));
            Value rval = _env->call(F, args);
            return qmodelindexlist(rval._Pointer);
        }
        else
        {
            return QAbstractItemModel::match(start, role, value, hits, flags);
        }
    }

    QMimeData*
    MuQt_QAbstractItemModel::mimeData(const QModelIndexList& indexes) const
    {
        if (!_env)
            return QAbstractItemModel::mimeData(indexes);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[15];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqmodelindexlist(c, indexes));
            Value rval = _env->call(F, args);
            return object<QMimeData>(rval._Pointer);
        }
        else
        {
            return QAbstractItemModel::mimeData(indexes);
        }
    }

    QStringList MuQt_QAbstractItemModel::mimeTypes() const
    {
        if (!_env)
            return QAbstractItemModel::mimeTypes();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[16];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return qstringlist(rval._Pointer);
        }
        else
        {
            return QAbstractItemModel::mimeTypes();
        }
    }

    bool MuQt_QAbstractItemModel::moveColumns(
        const QModelIndex& sourceParent, int sourceColumn, int count,
        const QModelIndex& destinationParent, int destinationChild)
    {
        if (!_env)
            return QAbstractItemModel::moveColumns(sourceParent, sourceColumn,
                                                   count, destinationParent,
                                                   destinationChild);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[17];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(6);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqtype<QModelIndexType>(c, sourceParent, "qt.QModelIndex"));
            args[2] = Value(sourceColumn);
            args[3] = Value(count);
            args[4] = Value(makeqtype<QModelIndexType>(c, destinationParent,
                                                       "qt.QModelIndex"));
            args[5] = Value(destinationChild);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::moveColumns(sourceParent, sourceColumn,
                                                   count, destinationParent,
                                                   destinationChild);
        }
    }

    bool MuQt_QAbstractItemModel::moveRows(const QModelIndex& sourceParent,
                                           int sourceRow, int count,
                                           const QModelIndex& destinationParent,
                                           int destinationChild)
    {
        if (!_env)
            return QAbstractItemModel::moveRows(sourceParent, sourceRow, count,
                                                destinationParent,
                                                destinationChild);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[18];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(6);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqtype<QModelIndexType>(c, sourceParent, "qt.QModelIndex"));
            args[2] = Value(sourceRow);
            args[3] = Value(count);
            args[4] = Value(makeqtype<QModelIndexType>(c, destinationParent,
                                                       "qt.QModelIndex"));
            args[5] = Value(destinationChild);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::moveRows(sourceParent, sourceRow, count,
                                                destinationParent,
                                                destinationChild);
        }
    }

    QModelIndex MuQt_QAbstractItemModel::parent(
        const QModelIndex& index) const // pure virtual
    {
        if (!_env)
            return defaultValue<QModelIndex>();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[19];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return getqtype<QModelIndexType>(rval._Pointer);
        }
        else
        {
            return defaultValue<QModelIndex>();
        }
    }

    bool MuQt_QAbstractItemModel::removeColumns(int column, int count,
                                                const QModelIndex& parent)
    {
        if (!_env)
            return QAbstractItemModel::removeColumns(column, count, parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[20];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(column);
            args[2] = Value(count);
            args[3] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::removeColumns(column, count, parent);
        }
    }

    bool MuQt_QAbstractItemModel::removeRows(int row, int count,
                                             const QModelIndex& parent)
    {
        if (!_env)
            return QAbstractItemModel::removeRows(row, count, parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[21];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(row);
            args[2] = Value(count);
            args[3] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::removeRows(row, count, parent);
        }
    }

    int MuQt_QAbstractItemModel::rowCount(
        const QModelIndex& parent) const // pure virtual
    {
        if (!_env)
            return defaultValue<int>();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[22];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return defaultValue<int>();
        }
    }

    bool MuQt_QAbstractItemModel::setData(const QModelIndex& index,
                                          const QVariant& value, int role)
    {
        if (!_env)
            return QAbstractItemModel::setData(index, value, role);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[23];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            args[2] = Value(makeqtype<QVariantType>(c, value, "qt.QVariant"));
            args[3] = Value(role);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::setData(index, value, role);
        }
    }

    bool MuQt_QAbstractItemModel::setHeaderData(int section,
                                                Qt::Orientation orientation,
                                                const QVariant& value, int role)
    {
        if (!_env)
            return QAbstractItemModel::setHeaderData(section, orientation,
                                                     value, role);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[24];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(5);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(section);
            args[2] = Value(int(orientation));
            args[3] = Value(makeqtype<QVariantType>(c, value, "qt.QVariant"));
            args[4] = Value(role);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::setHeaderData(section, orientation,
                                                     value, role);
        }
    }

    QModelIndex MuQt_QAbstractItemModel::sibling(int row, int column,
                                                 const QModelIndex& index) const
    {
        if (!_env)
            return QAbstractItemModel::sibling(row, column, index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[25];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(row);
            args[2] = Value(column);
            args[3] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return getqtype<QModelIndexType>(rval._Pointer);
        }
        else
        {
            return QAbstractItemModel::sibling(row, column, index);
        }
    }

    void MuQt_QAbstractItemModel::sort(int column, Qt::SortOrder order)
    {
        if (!_env)
        {
            QAbstractItemModel::sort(column, order);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[26];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(column);
            args[2] = Value(int(order));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractItemModel::sort(column, order);
        }
    }

    QSize MuQt_QAbstractItemModel::span(const QModelIndex& index) const
    {
        if (!_env)
            return QAbstractItemModel::span(index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[27];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QAbstractItemModel::span(index);
        }
    }

    Qt::DropActions MuQt_QAbstractItemModel::supportedDragActions() const
    {
        if (!_env)
            return QAbstractItemModel::supportedDragActions();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[28];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (Qt::DropActions)(rval._int);
        }
        else
        {
            return QAbstractItemModel::supportedDragActions();
        }
    }

    Qt::DropActions MuQt_QAbstractItemModel::supportedDropActions() const
    {
        if (!_env)
            return QAbstractItemModel::supportedDropActions();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[29];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (Qt::DropActions)(rval._int);
        }
        else
        {
            return QAbstractItemModel::supportedDropActions();
        }
    }

    bool MuQt_QAbstractItemModel::event(QEvent* e)
    {
        if (!_env)
            return QAbstractItemModel::event(e);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[30];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, e, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::event(e);
        }
    }

    bool MuQt_QAbstractItemModel::eventFilter(QObject* watched, QEvent* event)
    {
        if (!_env)
            return QAbstractItemModel::eventFilter(watched, event);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[31];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeinstance<QObjectType>(c, watched, "qt.QObject"));
            args[2] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractItemModel::eventFilter(watched, event);
        }
    }

    void MuQt_QAbstractItemModel::customEvent(QEvent* event)
    {
        if (!_env)
        {
            QAbstractItemModel::customEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[32];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractItemModel::customEvent(event);
        }
    }

    void MuQt_QAbstractItemModel::timerEvent(QTimerEvent* event)
    {
        if (!_env)
        {
            QAbstractItemModel::timerEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[33];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QTimerEventType>(c, event, "qt.QTimerEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractItemModel::timerEvent(event);
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QAbstractItemModelType::QAbstractItemModelType(Context* c, const char* name,
                                                   Class* super, Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QAbstractItemModelType::~QAbstractItemModelType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer
    QAbstractItemModel_QAbstractItemModel_QObject(Thread& NODE_THREAD,
                                                  Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QAbstractItemModel* w = object<QAbstractItemModel>(widget))
        {
            QAbstractItemModelType* type =
                c->findSymbolOfTypeByQualifiedName<QAbstractItemModelType>(
                    c->internName("qt.QAbstractItemModel"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(QAbstractItemModel_QAbstractItemModel_QObject(
            NODE_THREAD, NODE_ARG(0, Pointer)));
    }

    Pointer
    qt_QAbstractItemModel_QAbstractItemModel_QAbstractItemModel_QAbstractItemModel_QObject(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QObject* arg1 = object<QObject>(param_parent);
        setobject(param_this,
                  new MuQt_QAbstractItemModel(
                      param_this, NODE_THREAD.process()->callEnv(), arg1));
        return param_this;
    }

    Pointer
    qt_QAbstractItemModel_buddy_QModelIndex_QAbstractItemModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0)
                   ? makeqtype<QModelIndexType>(
                         c, arg0->QAbstractItemModel::buddy(arg1),
                         "qt.QModelIndex")
                   : makeqtype<QModelIndexType>(c, arg0->buddy(arg1),
                                                "qt.QModelIndex");
    }

    bool
    qt_QAbstractItemModel_canDropMimeData_bool_QAbstractItemModel_QMimeData_int_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_data,
        int param_action, int param_row, int param_column, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QMimeData* arg1 = object<QMimeData>(param_data);
        Qt::DropAction arg2 = (Qt::DropAction)(param_action);
        int arg3 = (int)(param_row);
        int arg4 = (int)(param_column);
        const QModelIndex arg5 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractItemModel::canDropMimeData(arg1, arg2, arg3,
                                                               arg4, arg5)
                   : arg0->canDropMimeData(arg1, arg2, arg3, arg4, arg5);
    }

    bool qt_QAbstractItemModel_canFetchMore_bool_QAbstractItemModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0) ? arg0->QAbstractItemModel::canFetchMore(arg1)
                                  : arg0->canFetchMore(arg1);
    }

    bool
    qt_QAbstractItemModel_clearItemData_bool_QAbstractItemModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractItemModel::clearItemData(arg1)
                   : arg0->clearItemData(arg1);
    }

    int qt_QAbstractItemModel_columnCount_int_QAbstractItemModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_parent);
        return arg0->columnCount(arg1);
    }

    Pointer
    qt_QAbstractItemModel_data_QVariant_QAbstractItemModel_QModelIndex_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index,
        int param_role)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        int arg2 = (int)(param_role);
        return makeqtype<QVariantType>(c, arg0->data(arg1, arg2),
                                       "qt.QVariant");
    }

    bool
    qt_QAbstractItemModel_dropMimeData_bool_QAbstractItemModel_QMimeData_int_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_data,
        int param_action, int param_row, int param_column, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QMimeData* arg1 = object<QMimeData>(param_data);
        Qt::DropAction arg2 = (Qt::DropAction)(param_action);
        int arg3 = (int)(param_row);
        int arg4 = (int)(param_column);
        const QModelIndex arg5 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractItemModel::dropMimeData(arg1, arg2, arg3,
                                                            arg4, arg5)
                   : arg0->dropMimeData(arg1, arg2, arg3, arg4, arg5);
    }

    void qt_QAbstractItemModel_fetchMore_void_QAbstractItemModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_parent);
        if (isMuQtObject(arg0))
            arg0->QAbstractItemModel::fetchMore(arg1);
        else
            arg0->fetchMore(arg1);
    }

    int qt_QAbstractItemModel_flags_int_QAbstractItemModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0) ? int(arg0->QAbstractItemModel::flags(arg1))
                                  : int(arg0->flags(arg1));
    }

    bool qt_QAbstractItemModel_hasChildren_bool_QAbstractItemModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0) ? arg0->QAbstractItemModel::hasChildren(arg1)
                                  : arg0->hasChildren(arg1);
    }

    bool
    qt_QAbstractItemModel_hasIndex_bool_QAbstractItemModel_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        int param_column, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_column);
        const QModelIndex arg3 = getqtype<QModelIndexType>(param_parent);
        return arg0->hasIndex(arg1, arg2, arg3);
    }

    Pointer
    qt_QAbstractItemModel_headerData_QVariant_QAbstractItemModel_int_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_section,
        int param_orientation, int param_role)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_section);
        Qt::Orientation arg2 = (Qt::Orientation)(param_orientation);
        int arg3 = (int)(param_role);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c,
                         arg0->QAbstractItemModel::headerData(arg1, arg2, arg3),
                         "qt.QVariant")
                   : makeqtype<QVariantType>(
                         c, arg0->headerData(arg1, arg2, arg3), "qt.QVariant");
    }

    Pointer
    qt_QAbstractItemModel_index_QModelIndex_QAbstractItemModel_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        int param_column, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_column);
        const QModelIndex arg3 = getqtype<QModelIndexType>(param_parent);
        return makeqtype<QModelIndexType>(c, arg0->index(arg1, arg2, arg3),
                                          "qt.QModelIndex");
    }

    bool
    qt_QAbstractItemModel_insertColumn_bool_QAbstractItemModel_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column,
        Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_column);
        const QModelIndex arg2 = getqtype<QModelIndexType>(param_parent);
        return arg0->insertColumn(arg1, arg2);
    }

    bool
    qt_QAbstractItemModel_insertColumns_bool_QAbstractItemModel_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column,
        int param_count, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_column);
        int arg2 = (int)(param_count);
        const QModelIndex arg3 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractItemModel::insertColumns(arg1, arg2, arg3)
                   : arg0->insertColumns(arg1, arg2, arg3);
    }

    bool
    qt_QAbstractItemModel_insertRow_bool_QAbstractItemModel_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_row);
        const QModelIndex arg2 = getqtype<QModelIndexType>(param_parent);
        return arg0->insertRow(arg1, arg2);
    }

    bool
    qt_QAbstractItemModel_insertRows_bool_QAbstractItemModel_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        int param_count, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_count);
        const QModelIndex arg3 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractItemModel::insertRows(arg1, arg2, arg3)
                   : arg0->insertRows(arg1, arg2, arg3);
    }

    Pointer
    qt_QAbstractItemModel_match_qt__QModelIndexBSB_ESB__QAbstractItemModel_QModelIndex_int_QVariant_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_start,
        int param_role, Pointer param_value, int param_hits, int param_flags)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_start);
        int arg2 = (int)(param_role);
        const QVariant arg3 = getqtype<QVariantType>(param_value);
        int arg4 = (int)(param_hits);
        Qt::MatchFlags arg5 = (Qt::MatchFlags)(param_flags);
        return isMuQtObject(arg0)
                   ? makeqmodelindexlist(c, arg0->QAbstractItemModel::match(
                                                arg1, arg2, arg3, arg4, arg5))
                   : makeqmodelindexlist(
                         c, arg0->match(arg1, arg2, arg3, arg4, arg5));
    }

    Pointer
    qt_QAbstractItemModel_mimeData_QMimeData_QAbstractItemModel_qt__QModelIndexBSB_ESB_(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_indexes)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndexList arg1 = qmodelindexlist(param_indexes);
        return isMuQtObject(arg0)
                   ? makeinstance<QMimeDataType>(
                         c, arg0->QAbstractItemModel::mimeData(arg1),
                         "qt.QMimeData")
                   : makeinstance<QMimeDataType>(c, arg0->mimeData(arg1),
                                                 "qt.QMimeData");
    }

    Pointer qt_QAbstractItemModel_mimeTypes_stringBSB_ESB__QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        return isMuQtObject(arg0)
                   ? makestringlist(c, arg0->QAbstractItemModel::mimeTypes())
                   : makestringlist(c, arg0->mimeTypes());
    }

    bool
    qt_QAbstractItemModel_moveColumn_bool_QAbstractItemModel_QModelIndex_int_QModelIndex_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_sourceParent,
        int param_sourceColumn, Pointer param_destinationParent,
        int param_destinationChild)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_sourceParent);
        int arg2 = (int)(param_sourceColumn);
        const QModelIndex arg3 =
            getqtype<QModelIndexType>(param_destinationParent);
        int arg4 = (int)(param_destinationChild);
        return arg0->moveColumn(arg1, arg2, arg3, arg4);
    }

    bool
    qt_QAbstractItemModel_moveColumns_bool_QAbstractItemModel_QModelIndex_int_int_QModelIndex_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_sourceParent,
        int param_sourceColumn, int param_count,
        Pointer param_destinationParent, int param_destinationChild)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_sourceParent);
        int arg2 = (int)(param_sourceColumn);
        int arg3 = (int)(param_count);
        const QModelIndex arg4 =
            getqtype<QModelIndexType>(param_destinationParent);
        int arg5 = (int)(param_destinationChild);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractItemModel::moveColumns(arg1, arg2, arg3,
                                                           arg4, arg5)
                   : arg0->moveColumns(arg1, arg2, arg3, arg4, arg5);
    }

    bool
    qt_QAbstractItemModel_moveRow_bool_QAbstractItemModel_QModelIndex_int_QModelIndex_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_sourceParent,
        int param_sourceRow, Pointer param_destinationParent,
        int param_destinationChild)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_sourceParent);
        int arg2 = (int)(param_sourceRow);
        const QModelIndex arg3 =
            getqtype<QModelIndexType>(param_destinationParent);
        int arg4 = (int)(param_destinationChild);
        return arg0->moveRow(arg1, arg2, arg3, arg4);
    }

    bool
    qt_QAbstractItemModel_moveRows_bool_QAbstractItemModel_QModelIndex_int_int_QModelIndex_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_sourceParent,
        int param_sourceRow, int param_count, Pointer param_destinationParent,
        int param_destinationChild)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_sourceParent);
        int arg2 = (int)(param_sourceRow);
        int arg3 = (int)(param_count);
        const QModelIndex arg4 =
            getqtype<QModelIndexType>(param_destinationParent);
        int arg5 = (int)(param_destinationChild);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractItemModel::moveRows(arg1, arg2, arg3, arg4,
                                                        arg5)
                   : arg0->moveRows(arg1, arg2, arg3, arg4, arg5);
    }

    Pointer
    qt_QAbstractItemModel_parent_QModelIndex_QAbstractItemModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return makeqtype<QModelIndexType>(c, arg0->parent(arg1),
                                          "qt.QModelIndex");
    }

    bool
    qt_QAbstractItemModel_removeColumn_bool_QAbstractItemModel_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column,
        Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_column);
        const QModelIndex arg2 = getqtype<QModelIndexType>(param_parent);
        return arg0->removeColumn(arg1, arg2);
    }

    bool
    qt_QAbstractItemModel_removeColumns_bool_QAbstractItemModel_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column,
        int param_count, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_column);
        int arg2 = (int)(param_count);
        const QModelIndex arg3 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractItemModel::removeColumns(arg1, arg2, arg3)
                   : arg0->removeColumns(arg1, arg2, arg3);
    }

    bool
    qt_QAbstractItemModel_removeRow_bool_QAbstractItemModel_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_row);
        const QModelIndex arg2 = getqtype<QModelIndexType>(param_parent);
        return arg0->removeRow(arg1, arg2);
    }

    bool
    qt_QAbstractItemModel_removeRows_bool_QAbstractItemModel_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        int param_count, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_count);
        const QModelIndex arg3 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractItemModel::removeRows(arg1, arg2, arg3)
                   : arg0->removeRows(arg1, arg2, arg3);
    }

    int qt_QAbstractItemModel_rowCount_int_QAbstractItemModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_parent);
        return arg0->rowCount(arg1);
    }

    bool
    qt_QAbstractItemModel_setData_bool_QAbstractItemModel_QModelIndex_QVariant_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index,
        Pointer param_value, int param_role)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        const QVariant arg2 = getqtype<QVariantType>(param_value);
        int arg3 = (int)(param_role);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractItemModel::setData(arg1, arg2, arg3)
                   : arg0->setData(arg1, arg2, arg3);
    }

    bool
    qt_QAbstractItemModel_setHeaderData_bool_QAbstractItemModel_int_int_QVariant_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_section,
        int param_orientation, Pointer param_value, int param_role)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_section);
        Qt::Orientation arg2 = (Qt::Orientation)(param_orientation);
        const QVariant arg3 = getqtype<QVariantType>(param_value);
        int arg4 = (int)(param_role);
        return isMuQtObject(arg0) ? arg0->QAbstractItemModel::setHeaderData(
                                        arg1, arg2, arg3, arg4)
                                  : arg0->setHeaderData(arg1, arg2, arg3, arg4);
    }

    Pointer
    qt_QAbstractItemModel_sibling_QModelIndex_QAbstractItemModel_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        int param_column, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_column);
        const QModelIndex arg3 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0)
                   ? makeqtype<QModelIndexType>(
                         c, arg0->QAbstractItemModel::sibling(arg1, arg2, arg3),
                         "qt.QModelIndex")
                   : makeqtype<QModelIndexType>(
                         c, arg0->sibling(arg1, arg2, arg3), "qt.QModelIndex");
    }

    void qt_QAbstractItemModel_sort_void_QAbstractItemModel_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column,
        int param_order)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        int arg1 = (int)(param_column);
        Qt::SortOrder arg2 = (Qt::SortOrder)(param_order);
        if (isMuQtObject(arg0))
            arg0->QAbstractItemModel::sort(arg1, arg2);
        else
            arg0->sort(arg1, arg2);
    }

    Pointer qt_QAbstractItemModel_span_QSize_QAbstractItemModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(
                         c, arg0->QAbstractItemModel::span(arg1), "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->span(arg1), "qt.QSize");
    }

    int qt_QAbstractItemModel_supportedDragActions_int_QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        return isMuQtObject(arg0)
                   ? int(arg0->QAbstractItemModel::supportedDragActions())
                   : int(arg0->supportedDragActions());
    }

    int qt_QAbstractItemModel_supportedDropActions_int_QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        return isMuQtObject(arg0)
                   ? int(arg0->QAbstractItemModel::supportedDropActions())
                   : int(arg0->supportedDropActions());
    }

    void
    qt_QAbstractItemModel_beginInsertColumns_void_QAbstractItemModel_QModelIndex_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent,
        int param_first, int param_last)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_parent);
        int arg2 = (int)(param_first);
        int arg3 = (int)(param_last);
        ((MuQt_QAbstractItemModel*)arg0)
            ->beginInsertColumns_pub(arg1, arg2, arg3);
    }

    void
    qt_QAbstractItemModel_beginInsertRows_void_QAbstractItemModel_QModelIndex_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent,
        int param_first, int param_last)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_parent);
        int arg2 = (int)(param_first);
        int arg3 = (int)(param_last);
        ((MuQt_QAbstractItemModel*)arg0)->beginInsertRows_pub(arg1, arg2, arg3);
    }

    bool
    qt_QAbstractItemModel_beginMoveColumns_bool_QAbstractItemModel_QModelIndex_int_int_QModelIndex_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_sourceParent,
        int param_sourceFirst, int param_sourceLast,
        Pointer param_destinationParent, int param_destinationChild)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_sourceParent);
        int arg2 = (int)(param_sourceFirst);
        int arg3 = (int)(param_sourceLast);
        const QModelIndex arg4 =
            getqtype<QModelIndexType>(param_destinationParent);
        int arg5 = (int)(param_destinationChild);
        return ((MuQt_QAbstractItemModel*)arg0)
            ->beginMoveColumns_pub(arg1, arg2, arg3, arg4, arg5);
    }

    bool
    qt_QAbstractItemModel_beginMoveRows_bool_QAbstractItemModel_QModelIndex_int_int_QModelIndex_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_sourceParent,
        int param_sourceFirst, int param_sourceLast,
        Pointer param_destinationParent, int param_destinationChild)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_sourceParent);
        int arg2 = (int)(param_sourceFirst);
        int arg3 = (int)(param_sourceLast);
        const QModelIndex arg4 =
            getqtype<QModelIndexType>(param_destinationParent);
        int arg5 = (int)(param_destinationChild);
        return ((MuQt_QAbstractItemModel*)arg0)
            ->beginMoveRows_pub(arg1, arg2, arg3, arg4, arg5);
    }

    void
    qt_QAbstractItemModel_beginRemoveColumns_void_QAbstractItemModel_QModelIndex_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent,
        int param_first, int param_last)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_parent);
        int arg2 = (int)(param_first);
        int arg3 = (int)(param_last);
        ((MuQt_QAbstractItemModel*)arg0)
            ->beginRemoveColumns_pub(arg1, arg2, arg3);
    }

    void
    qt_QAbstractItemModel_beginRemoveRows_void_QAbstractItemModel_QModelIndex_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent,
        int param_first, int param_last)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_parent);
        int arg2 = (int)(param_first);
        int arg3 = (int)(param_last);
        ((MuQt_QAbstractItemModel*)arg0)->beginRemoveRows_pub(arg1, arg2, arg3);
    }

    void qt_QAbstractItemModel_beginResetModel_void_QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        ((MuQt_QAbstractItemModel*)arg0)->beginResetModel_pub();
    }

    void
    qt_QAbstractItemModel_changePersistentIndex_void_QAbstractItemModel_QModelIndex_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_from,
        Pointer param_to)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_from);
        const QModelIndex arg2 = getqtype<QModelIndexType>(param_to);
        ((MuQt_QAbstractItemModel*)arg0)->changePersistentIndex_pub(arg1, arg2);
    }

    void
    qt_QAbstractItemModel_changePersistentIndexList_void_QAbstractItemModel_qt__QModelIndexBSB_ESB__qt__QModelIndexBSB_ESB_(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_from,
        Pointer param_to)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        const QModelIndexList arg1 = qmodelindexlist(param_from);
        const QModelIndexList arg2 = qmodelindexlist(param_to);
        ((MuQt_QAbstractItemModel*)arg0)
            ->changePersistentIndexList_pub(arg1, arg2);
    }

    void qt_QAbstractItemModel_endInsertColumns_void_QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        ((MuQt_QAbstractItemModel*)arg0)->endInsertColumns_pub();
    }

    void qt_QAbstractItemModel_endInsertRows_void_QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        ((MuQt_QAbstractItemModel*)arg0)->endInsertRows_pub();
    }

    void qt_QAbstractItemModel_endMoveColumns_void_QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        ((MuQt_QAbstractItemModel*)arg0)->endMoveColumns_pub();
    }

    void qt_QAbstractItemModel_endMoveRows_void_QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        ((MuQt_QAbstractItemModel*)arg0)->endMoveRows_pub();
    }

    void qt_QAbstractItemModel_endRemoveColumns_void_QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        ((MuQt_QAbstractItemModel*)arg0)->endRemoveColumns_pub();
    }

    void qt_QAbstractItemModel_endRemoveRows_void_QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        ((MuQt_QAbstractItemModel*)arg0)->endRemoveRows_pub();
    }

    void qt_QAbstractItemModel_endResetModel_void_QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        ((MuQt_QAbstractItemModel*)arg0)->endResetModel_pub();
    }

    Pointer
    qt_QAbstractItemModel_persistentIndexList_qt__QModelIndexBSB_ESB__QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        return makeqmodelindexlist(
            c, ((MuQt_QAbstractItemModel*)arg0)->persistentIndexList_pub());
    }

    bool qt_QAbstractItemModel_event_bool_QAbstractItemModel_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_e);
        return isMuQtObject(arg0) ? arg0->QAbstractItemModel::event(arg1)
                                  : arg0->event(arg1);
    }

    bool
    qt_QAbstractItemModel_eventFilter_bool_QAbstractItemModel_QObject_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_watched,
        Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        QObject* arg1 = object<QObject>(param_watched);
        QEvent* arg2 = getqpointer<QEventType>(param_event);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractItemModel::eventFilter(arg1, arg2)
                   : arg0->eventFilter(arg1, arg2);
    }

    void qt_QAbstractItemModel_customEvent_void_QAbstractItemModel_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractItemModel*)arg0)->customEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractItemModel*)arg0)->customEvent_pub(arg1);
    }

    void qt_QAbstractItemModel_timerEvent_void_QAbstractItemModel_QTimerEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractItemModel* arg0 = object<QAbstractItemModel>(param_this);
        QTimerEvent* arg1 = getqpointer<QTimerEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractItemModel*)arg0)->timerEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractItemModel*)arg0)->timerEvent_pub(arg1);
    }

    static NODE_IMPLEMENTATION(_n_QAbstractItemModel0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_QAbstractItemModel_QAbstractItemModel_QAbstractItemModel_QObject(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_buddy0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_buddy_QModelIndex_QAbstractItemModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_canDropMimeData0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_canDropMimeData_bool_QAbstractItemModel_QMimeData_int_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, int), NODE_ARG(4, int),
                NODE_ARG(5, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_canFetchMore0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_canFetchMore_bool_QAbstractItemModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_clearItemData0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_clearItemData_bool_QAbstractItemModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_columnCount0, int)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_columnCount_int_QAbstractItemModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_data0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_data_QVariant_QAbstractItemModel_QModelIndex_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int)));
    }

    static NODE_IMPLEMENTATION(_n_dropMimeData0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_dropMimeData_bool_QAbstractItemModel_QMimeData_int_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, int), NODE_ARG(4, int),
                NODE_ARG(5, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_fetchMore0, void)
    {
        qt_QAbstractItemModel_fetchMore_void_QAbstractItemModel_QModelIndex(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_flags0, int)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_flags_int_QAbstractItemModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_hasChildren0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_hasChildren_bool_QAbstractItemModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_hasIndex0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_hasIndex_bool_QAbstractItemModel_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_headerData0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_headerData_QVariant_QAbstractItemModel_int_int_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, int)));
    }

    static NODE_IMPLEMENTATION(_n_index0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_index_QModelIndex_QAbstractItemModel_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_insertColumn0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_insertColumn_bool_QAbstractItemModel_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_insertColumns0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_insertColumns_bool_QAbstractItemModel_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_insertRow0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_insertRow_bool_QAbstractItemModel_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_insertRows0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_insertRows_bool_QAbstractItemModel_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_match0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_match_qt__QModelIndexBSB_ESB__QAbstractItemModel_QModelIndex_int_QVariant_int_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, Pointer), NODE_ARG(4, int),
                NODE_ARG(5, int)));
    }

    static NODE_IMPLEMENTATION(_n_mimeData0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_mimeData_QMimeData_QAbstractItemModel_qt__QModelIndexBSB_ESB_(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_mimeTypes0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_mimeTypes_stringBSB_ESB__QAbstractItemModel(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_moveColumn0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_moveColumn_bool_QAbstractItemModel_QModelIndex_int_QModelIndex_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, Pointer), NODE_ARG(4, int)));
    }

    static NODE_IMPLEMENTATION(_n_moveColumns0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_moveColumns_bool_QAbstractItemModel_QModelIndex_int_int_QModelIndex_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, int), NODE_ARG(4, Pointer),
                NODE_ARG(5, int)));
    }

    static NODE_IMPLEMENTATION(_n_moveRow0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_moveRow_bool_QAbstractItemModel_QModelIndex_int_QModelIndex_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, Pointer), NODE_ARG(4, int)));
    }

    static NODE_IMPLEMENTATION(_n_moveRows0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_moveRows_bool_QAbstractItemModel_QModelIndex_int_int_QModelIndex_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, int), NODE_ARG(4, Pointer),
                NODE_ARG(5, int)));
    }

    static NODE_IMPLEMENTATION(_n_parent0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_parent_QModelIndex_QAbstractItemModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_removeColumn0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_removeColumn_bool_QAbstractItemModel_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_removeColumns0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_removeColumns_bool_QAbstractItemModel_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_removeRow0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_removeRow_bool_QAbstractItemModel_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_removeRows0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_removeRows_bool_QAbstractItemModel_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_rowCount0, int)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_rowCount_int_QAbstractItemModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_setData0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_setData_bool_QAbstractItemModel_QModelIndex_QVariant_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, Pointer), NODE_ARG(3, int)));
    }

    static NODE_IMPLEMENTATION(_n_setHeaderData0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_setHeaderData_bool_QAbstractItemModel_int_int_QVariant_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer), NODE_ARG(4, int)));
    }

    static NODE_IMPLEMENTATION(_n_sibling0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_sibling_QModelIndex_QAbstractItemModel_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_sort0, void)
    {
        qt_QAbstractItemModel_sort_void_QAbstractItemModel_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_span0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_span_QSize_QAbstractItemModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_supportedDragActions0, int)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_supportedDragActions_int_QAbstractItemModel(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_supportedDropActions0, int)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_supportedDropActions_int_QAbstractItemModel(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_beginInsertColumns0, void)
    {
        qt_QAbstractItemModel_beginInsertColumns_void_QAbstractItemModel_QModelIndex_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int), NODE_ARG(3, int));
    }

    static NODE_IMPLEMENTATION(_n_beginInsertRows0, void)
    {
        qt_QAbstractItemModel_beginInsertRows_void_QAbstractItemModel_QModelIndex_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int), NODE_ARG(3, int));
    }

    static NODE_IMPLEMENTATION(_n_beginMoveColumns0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_beginMoveColumns_bool_QAbstractItemModel_QModelIndex_int_int_QModelIndex_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, int), NODE_ARG(4, Pointer),
                NODE_ARG(5, int)));
    }

    static NODE_IMPLEMENTATION(_n_beginMoveRows0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_beginMoveRows_bool_QAbstractItemModel_QModelIndex_int_int_QModelIndex_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, int), NODE_ARG(4, Pointer),
                NODE_ARG(5, int)));
    }

    static NODE_IMPLEMENTATION(_n_beginRemoveColumns0, void)
    {
        qt_QAbstractItemModel_beginRemoveColumns_void_QAbstractItemModel_QModelIndex_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int), NODE_ARG(3, int));
    }

    static NODE_IMPLEMENTATION(_n_beginRemoveRows0, void)
    {
        qt_QAbstractItemModel_beginRemoveRows_void_QAbstractItemModel_QModelIndex_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int), NODE_ARG(3, int));
    }

    static NODE_IMPLEMENTATION(_n_beginResetModel0, void)
    {
        qt_QAbstractItemModel_beginResetModel_void_QAbstractItemModel(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_changePersistentIndex0, void)
    {
        qt_QAbstractItemModel_changePersistentIndex_void_QAbstractItemModel_QModelIndex_QModelIndex(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_changePersistentIndexList0, void)
    {
        qt_QAbstractItemModel_changePersistentIndexList_void_QAbstractItemModel_qt__QModelIndexBSB_ESB__qt__QModelIndexBSB_ESB_(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_endInsertColumns0, void)
    {
        qt_QAbstractItemModel_endInsertColumns_void_QAbstractItemModel(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_endInsertRows0, void)
    {
        qt_QAbstractItemModel_endInsertRows_void_QAbstractItemModel(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_endMoveColumns0, void)
    {
        qt_QAbstractItemModel_endMoveColumns_void_QAbstractItemModel(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_endMoveRows0, void)
    {
        qt_QAbstractItemModel_endMoveRows_void_QAbstractItemModel(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_endRemoveColumns0, void)
    {
        qt_QAbstractItemModel_endRemoveColumns_void_QAbstractItemModel(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_endRemoveRows0, void)
    {
        qt_QAbstractItemModel_endRemoveRows_void_QAbstractItemModel(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_endResetModel0, void)
    {
        qt_QAbstractItemModel_endResetModel_void_QAbstractItemModel(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_persistentIndexList0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_persistentIndexList_qt__QModelIndexBSB_ESB__QAbstractItemModel(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QAbstractItemModel_event_bool_QAbstractItemModel_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_eventFilter0, bool)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_eventFilter_bool_QAbstractItemModel_QObject_QEvent(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_customEvent0, void)
    {
        qt_QAbstractItemModel_customEvent_void_QAbstractItemModel_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_timerEvent0, void)
    {
        qt_QAbstractItemModel_timerEvent_void_QAbstractItemModel_QTimerEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    //
    // Copyright (C) 2023  Autodesk, Inc. All Rights Reserved.
    //
    // SPDX-License-Identifier: Apache-2.0
    //

    Pointer
    qt_QAbstractItemModel_createIndex_QModelIndex_QAbstractItemModel_int_int_object(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        int param_column, Pointer param_any)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        MuQt_QAbstractItemModel* arg0 =
            object<MuQt_QAbstractItemModel>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_column);
        Pointer arg3 = (Pointer)(param_any);
        return makeqtype<QModelIndexType>(
            c, arg0->createIndex0_pub(arg1, arg2, arg3), "qt.QModelIndex");
    }

    static NODE_IMPLEMENTATION(_n_createIndex0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractItemModel_createIndex_QModelIndex_QAbstractItemModel_int_int_object(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    void QAbstractItemModelType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QAbstractItemModel_QAbstractItemModel_QObject,
                                Return, ftn, Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(
                c, "QAbstractItemModel", _n_QAbstractItemModel0, None, Compiled,
                qt_QAbstractItemModel_QAbstractItemModel_QAbstractItemModel_QAbstractItemModel_QObject,
                Return, "qt.QAbstractItemModel", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "parent", "qt.QObject"), End),
            _func[0] = new MemberFunction(
                c, "buddy", _n_buddy0, None, Compiled,
                qt_QAbstractItemModel_buddy_QModelIndex_QAbstractItemModel_QModelIndex,
                Return, "qt.QModelIndex", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[1] = new MemberFunction(
                c, "canDropMimeData", _n_canDropMimeData0, None, Compiled,
                qt_QAbstractItemModel_canDropMimeData_bool_QAbstractItemModel_QMimeData_int_int_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "data", "qt.QMimeData"),
                new Param(c, "action", "int"), new Param(c, "row", "int"),
                new Param(c, "column", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[2] = new MemberFunction(
                c, "canFetchMore", _n_canFetchMore0, None, Compiled,
                qt_QAbstractItemModel_canFetchMore_bool_QAbstractItemModel_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[3] = new MemberFunction(
                c, "clearItemData", _n_clearItemData0, None, Compiled,
                qt_QAbstractItemModel_clearItemData_bool_QAbstractItemModel_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[4] = new MemberFunction(
                c, "columnCount", _n_columnCount0, None, Compiled,
                qt_QAbstractItemModel_columnCount_int_QAbstractItemModel_QModelIndex,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[5] = new MemberFunction(
                c, "data", _n_data0, None, Compiled,
                qt_QAbstractItemModel_data_QVariant_QAbstractItemModel_QModelIndex_int,
                Return, "qt.QVariant", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "index", "qt.QModelIndex"),
                new Param(c, "role", "int", Value((int)Qt::DisplayRole)), End),
            _func[6] = new MemberFunction(
                c, "dropMimeData", _n_dropMimeData0, None, Compiled,
                qt_QAbstractItemModel_dropMimeData_bool_QAbstractItemModel_QMimeData_int_int_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "data", "qt.QMimeData"),
                new Param(c, "action", "int"), new Param(c, "row", "int"),
                new Param(c, "column", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[7] = new MemberFunction(
                c, "fetchMore", _n_fetchMore0, None, Compiled,
                qt_QAbstractItemModel_fetchMore_void_QAbstractItemModel_QModelIndex,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[8] = new MemberFunction(
                c, "flags", _n_flags0, None, Compiled,
                qt_QAbstractItemModel_flags_int_QAbstractItemModel_QModelIndex,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[9] = new MemberFunction(
                c, "hasChildren", _n_hasChildren0, None, Compiled,
                qt_QAbstractItemModel_hasChildren_bool_QAbstractItemModel_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            new Function(
                c, "hasIndex", _n_hasIndex0, None, Compiled,
                qt_QAbstractItemModel_hasIndex_bool_QAbstractItemModel_int_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "row", "int"), new Param(c, "column", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[10] = new MemberFunction(
                c, "headerData", _n_headerData0, None, Compiled,
                qt_QAbstractItemModel_headerData_QVariant_QAbstractItemModel_int_int_int,
                Return, "qt.QVariant", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "section", "int"),
                new Param(c, "orientation", "int"),
                new Param(c, "role", "int", Value((int)Qt::DisplayRole)), End),
            _func[11] = new MemberFunction(
                c, "index", _n_index0, None, Compiled,
                qt_QAbstractItemModel_index_QModelIndex_QAbstractItemModel_int_int_QModelIndex,
                Return, "qt.QModelIndex", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "row", "int"), new Param(c, "column", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            new Function(
                c, "insertColumn", _n_insertColumn0, None, Compiled,
                qt_QAbstractItemModel_insertColumn_bool_QAbstractItemModel_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "column", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[12] = new MemberFunction(
                c, "insertColumns", _n_insertColumns0, None, Compiled,
                qt_QAbstractItemModel_insertColumns_bool_QAbstractItemModel_int_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "column", "int"), new Param(c, "count", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            new Function(
                c, "insertRow", _n_insertRow0, None, Compiled,
                qt_QAbstractItemModel_insertRow_bool_QAbstractItemModel_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "row", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[13] = new MemberFunction(
                c, "insertRows", _n_insertRows0, None, Compiled,
                qt_QAbstractItemModel_insertRows_bool_QAbstractItemModel_int_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "row", "int"), new Param(c, "count", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            // MISSING: itemData ("QMap<int, QVariant>"; QAbstractItemModel
            // this, QModelIndex index)
            _func[14] = new MemberFunction(
                c, "match", _n_match0, None, Compiled,
                qt_QAbstractItemModel_match_qt__QModelIndexBSB_ESB__QAbstractItemModel_QModelIndex_int_QVariant_int_int,
                Return, "qt.QModelIndex[]", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "start", "qt.QModelIndex"),
                new Param(c, "role", "int"),
                new Param(c, "value", "qt.QVariant"),
                new Param(c, "hits", "int", Value((int)1)),
                new Param(c, "flags", "int",
                          Value((int)Qt::MatchFlags(Qt::MatchStartsWith
                                                    | Qt::MatchWrap))),
                End),
            _func[15] = new MemberFunction(
                c, "mimeData", _n_mimeData0, None, Compiled,
                qt_QAbstractItemModel_mimeData_QMimeData_QAbstractItemModel_qt__QModelIndexBSB_ESB_,
                Return, "qt.QMimeData", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "indexes", "qt.QModelIndex[]"), End),
            _func[16] = new MemberFunction(
                c, "mimeTypes", _n_mimeTypes0, None, Compiled,
                qt_QAbstractItemModel_mimeTypes_stringBSB_ESB__QAbstractItemModel,
                Return, "string[]", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"), End),
            new Function(
                c, "moveColumn", _n_moveColumn0, None, Compiled,
                qt_QAbstractItemModel_moveColumn_bool_QAbstractItemModel_QModelIndex_int_QModelIndex_int,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "sourceParent", "qt.QModelIndex"),
                new Param(c, "sourceColumn", "int"),
                new Param(c, "destinationParent", "qt.QModelIndex"),
                new Param(c, "destinationChild", "int"), End),
            _func[17] = new MemberFunction(
                c, "moveColumns", _n_moveColumns0, None, Compiled,
                qt_QAbstractItemModel_moveColumns_bool_QAbstractItemModel_QModelIndex_int_int_QModelIndex_int,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "sourceParent", "qt.QModelIndex"),
                new Param(c, "sourceColumn", "int"),
                new Param(c, "count", "int"),
                new Param(c, "destinationParent", "qt.QModelIndex"),
                new Param(c, "destinationChild", "int"), End),
            new Function(
                c, "moveRow", _n_moveRow0, None, Compiled,
                qt_QAbstractItemModel_moveRow_bool_QAbstractItemModel_QModelIndex_int_QModelIndex_int,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "sourceParent", "qt.QModelIndex"),
                new Param(c, "sourceRow", "int"),
                new Param(c, "destinationParent", "qt.QModelIndex"),
                new Param(c, "destinationChild", "int"), End),
            _func[18] = new MemberFunction(
                c, "moveRows", _n_moveRows0, None, Compiled,
                qt_QAbstractItemModel_moveRows_bool_QAbstractItemModel_QModelIndex_int_int_QModelIndex_int,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "sourceParent", "qt.QModelIndex"),
                new Param(c, "sourceRow", "int"), new Param(c, "count", "int"),
                new Param(c, "destinationParent", "qt.QModelIndex"),
                new Param(c, "destinationChild", "int"), End),
            // MISSING: multiData (void; QAbstractItemModel this, QModelIndex
            // index, "QModelRoleDataSpan" roleDataSpan)
            _func[19] = new MemberFunction(
                c, "parent", _n_parent0, None, Compiled,
                qt_QAbstractItemModel_parent_QModelIndex_QAbstractItemModel_QModelIndex,
                Return, "qt.QModelIndex", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "index", "qt.QModelIndex"), End),
            new Function(
                c, "removeColumn", _n_removeColumn0, None, Compiled,
                qt_QAbstractItemModel_removeColumn_bool_QAbstractItemModel_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "column", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[20] = new MemberFunction(
                c, "removeColumns", _n_removeColumns0, None, Compiled,
                qt_QAbstractItemModel_removeColumns_bool_QAbstractItemModel_int_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "column", "int"), new Param(c, "count", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            new Function(
                c, "removeRow", _n_removeRow0, None, Compiled,
                qt_QAbstractItemModel_removeRow_bool_QAbstractItemModel_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "row", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[21] = new MemberFunction(
                c, "removeRows", _n_removeRows0, None, Compiled,
                qt_QAbstractItemModel_removeRows_bool_QAbstractItemModel_int_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "row", "int"), new Param(c, "count", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            // MISSING: roleNames ("QHash<int, QByteArray>"; QAbstractItemModel
            // this)
            _func[22] = new MemberFunction(
                c, "rowCount", _n_rowCount0, None, Compiled,
                qt_QAbstractItemModel_rowCount_int_QAbstractItemModel_QModelIndex,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[23] = new MemberFunction(
                c, "setData", _n_setData0,
                None, Compiled,
                qt_QAbstractItemModel_setData_bool_QAbstractItemModel_QModelIndex_QVariant_int,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "index", "qt.QModelIndex"),
                new Param(c, "value", "qt.QVariant"),
                new Param(c, "role", "int", Value((int)Qt::EditRole)), End),
            _func[24] = new MemberFunction(
                c, "setHeaderData", _n_setHeaderData0, None, Compiled,
                qt_QAbstractItemModel_setHeaderData_bool_QAbstractItemModel_int_int_QVariant_int,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "section", "int"),
                new Param(c, "orientation", "int"),
                new Param(c, "value", "qt.QVariant"),
                new Param(c, "role", "int", Value((int)Qt::EditRole)), End),
            // MISSING: setItemData (bool; QAbstractItemModel this, QModelIndex
            // index, "const QMap<int, QVariant> &" roles)
            _func[25] = new MemberFunction(
                c, "sibling", _n_sibling0,
                None, Compiled,
                qt_QAbstractItemModel_sibling_QModelIndex_QAbstractItemModel_int_int_QModelIndex,
                Return, "qt.QModelIndex", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "row", "int"), new Param(c, "column", "int"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[26] = new MemberFunction(
                c, "sort", _n_sort0, None,
                Compiled,
                qt_QAbstractItemModel_sort_void_QAbstractItemModel_int_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "column", "int"),
                new Param(c, "order", "int", Value((int)Qt::AscendingOrder)),
                End),
            _func[27] = new MemberFunction(
                c, "span", _n_span0, None,
                Compiled,
                qt_QAbstractItemModel_span_QSize_QAbstractItemModel_QModelIndex,
                Return, "qt.QSize", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[28] = new MemberFunction(
                c, "supportedDragActions",
                _n_supportedDragActions0, None, Compiled,
                qt_QAbstractItemModel_supportedDragActions_int_QAbstractItemModel,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"), End),
            _func[29] = new MemberFunction(
                c, "supportedDropActions",
                _n_supportedDropActions0, None, Compiled,
                qt_QAbstractItemModel_supportedDropActions_int_QAbstractItemModel,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"), End),
            new Function(
                c, "beginInsertColumns", _n_beginInsertColumns0, None, Compiled,
                qt_QAbstractItemModel_beginInsertColumns_void_QAbstractItemModel_QModelIndex_int_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "parent", "qt.QModelIndex"),
                new Param(c, "first", "int"), new Param(c, "last", "int"), End),
            new Function(
                c, "beginInsertRows", _n_beginInsertRows0, None, Compiled,
                qt_QAbstractItemModel_beginInsertRows_void_QAbstractItemModel_QModelIndex_int_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "parent", "qt.QModelIndex"),
                new Param(c, "first", "int"), new Param(c, "last", "int"), End),
            new Function(
                c, "beginMoveColumns", _n_beginMoveColumns0, None, Compiled,
                qt_QAbstractItemModel_beginMoveColumns_bool_QAbstractItemModel_QModelIndex_int_int_QModelIndex_int,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "sourceParent", "qt.QModelIndex"),
                new Param(c, "sourceFirst", "int"),
                new Param(c, "sourceLast", "int"),
                new Param(c, "destinationParent", "qt.QModelIndex"),
                new Param(c, "destinationChild", "int"), End),
            new Function(
                c, "beginMoveRows", _n_beginMoveRows0, None, Compiled,
                qt_QAbstractItemModel_beginMoveRows_bool_QAbstractItemModel_QModelIndex_int_int_QModelIndex_int,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "sourceParent", "qt.QModelIndex"),
                new Param(c, "sourceFirst", "int"),
                new Param(c, "sourceLast", "int"),
                new Param(c, "destinationParent", "qt.QModelIndex"),
                new Param(c, "destinationChild", "int"), End),
            new Function(
                c, "beginRemoveColumns", _n_beginRemoveColumns0, None, Compiled,
                qt_QAbstractItemModel_beginRemoveColumns_void_QAbstractItemModel_QModelIndex_int_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "parent", "qt.QModelIndex"),
                new Param(c, "first", "int"), new Param(c, "last", "int"), End),
            new Function(
                c, "beginRemoveRows", _n_beginRemoveRows0, None, Compiled,
                qt_QAbstractItemModel_beginRemoveRows_void_QAbstractItemModel_QModelIndex_int_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "parent", "qt.QModelIndex"),
                new Param(c, "first", "int"), new Param(c, "last", "int"), End),
            new Function(
                c, "beginResetModel", _n_beginResetModel0, None, Compiled,
                qt_QAbstractItemModel_beginResetModel_void_QAbstractItemModel,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"), End),
            new Function(
                c, "changePersistentIndex", _n_changePersistentIndex0, None,
                Compiled,
                qt_QAbstractItemModel_changePersistentIndex_void_QAbstractItemModel_QModelIndex_QModelIndex,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "from", "qt.QModelIndex"),
                new Param(c, "to", "qt.QModelIndex"), End),
            new Function(
                c, "changePersistentIndexList", _n_changePersistentIndexList0,
                None, Compiled,
                qt_QAbstractItemModel_changePersistentIndexList_void_QAbstractItemModel_qt__QModelIndexBSB_ESB__qt__QModelIndexBSB_ESB_,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "from", "qt.QModelIndex[]"),
                new Param(c, "to", "qt.QModelIndex[]"), End),
            // MISSING: createIndex (QModelIndex; QAbstractItemModel this, int
            // row, int column, "const void *" ptr) // protected MISSING:
            // createIndex (QModelIndex; QAbstractItemModel this, int row, int
            // column, "quintptr" id) // protected
            new Function(
                c, "endInsertColumns", _n_endInsertColumns0, None, Compiled,
                qt_QAbstractItemModel_endInsertColumns_void_QAbstractItemModel,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"), End),
            new Function(
                c, "endInsertRows", _n_endInsertRows0, None, Compiled,
                qt_QAbstractItemModel_endInsertRows_void_QAbstractItemModel,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"), End),
            new Function(
                c, "endMoveColumns", _n_endMoveColumns0, None, Compiled,
                qt_QAbstractItemModel_endMoveColumns_void_QAbstractItemModel,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"), End),
            new Function(
                c, "endMoveRows", _n_endMoveRows0, None, Compiled,
                qt_QAbstractItemModel_endMoveRows_void_QAbstractItemModel,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"), End),
            new Function(
                c, "endRemoveColumns", _n_endRemoveColumns0, None, Compiled,
                qt_QAbstractItemModel_endRemoveColumns_void_QAbstractItemModel,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"), End),
            new Function(
                c, "endRemoveRows", _n_endRemoveRows0, None, Compiled,
                qt_QAbstractItemModel_endRemoveRows_void_QAbstractItemModel,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"), End),
            new Function(
                c, "endResetModel", _n_endResetModel0, None, Compiled,
                qt_QAbstractItemModel_endResetModel_void_QAbstractItemModel,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"), End),
            new Function(
                c, "persistentIndexList", _n_persistentIndexList0, None,
                Compiled,
                qt_QAbstractItemModel_persistentIndexList_qt__QModelIndexBSB_ESB__QAbstractItemModel,
                Return, "qt.QModelIndex[]", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"), End),
            _func[30] = new MemberFunction(
                c, "event", _n_event0, None, Compiled,
                qt_QAbstractItemModel_event_bool_QAbstractItemModel_QEvent,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "e", "qt.QEvent"), End),
            _func[31] = new MemberFunction(
                c, "eventFilter", _n_eventFilter0, None, Compiled,
                qt_QAbstractItemModel_eventFilter_bool_QAbstractItemModel_QObject_QEvent,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "watched", "qt.QObject"),
                new Param(c, "event", "qt.QEvent"), End),
            // MISSING: metaObject ("const QMetaObject *"; QAbstractItemModel
            // this) MISSING: childEvent (void; QAbstractItemModel this,
            // "QChildEvent *" event) // protected MISSING: connectNotify (void;
            // QAbstractItemModel this, "const QMetaMethod &" signal) //
            // protected
            _func[32] = new MemberFunction(
                c, "customEvent", _n_customEvent0, None, Compiled,
                qt_QAbstractItemModel_customEvent_void_QAbstractItemModel_QEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "event", "qt.QEvent"), End),
            // MISSING: disconnectNotify (void; QAbstractItemModel this, "const
            // QMetaMethod &" signal) // protected
            _func[33] = new MemberFunction(
                c, "timerEvent", _n_timerEvent0, None, Compiled,
                qt_QAbstractItemModel_timerEvent_void_QAbstractItemModel_QTimerEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "event", "qt.QTimerEvent"), End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        //
        // Copyright (C) 2023  Autodesk, Inc. All Rights Reserved.
        //
        // SPDX-License-Identifier: Apache-2.0
        //

        addSymbols(

            new Function(
                c, "createIndex", _n_createIndex0, None, Compiled,
                qt_QAbstractItemModel_createIndex_QModelIndex_QAbstractItemModel_int_int_object,
                Return, "qt.QModelIndex", Parameters,
                new Param(c, "this", "qt.QAbstractItemModel"),
                new Param(c, "row", "int"), new Param(c, "column", "int"),
                new Param(c, "any", "object"), End),

            EndArguments);

        const char** propExclusions = 0;

        populate(this, QAbstractItemModel::staticMetaObject, propExclusions);
    }

} // namespace Mu
