//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QDialogType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QSizeType.h>
#include <MuQt6/QDropEventType.h>
#include <MuQt6/QObjectType.h>
#include <MuQt6/QEventType.h>
#include <MuQt6/QPaintEventType.h>
#include <MuQt6/QMouseEventType.h>
#include <MuQt6/QCloseEventType.h>
#include <MuQt6/QTabletEventType.h>
#include <MuQt6/QDragMoveEventType.h>
#include <MuQt6/QVariantType.h>
#include <MuQt6/QContextMenuEventType.h>
#include <MuQt6/QKeyEventType.h>
#include <MuQt6/QFocusEventType.h>
#include <MuQt6/QMoveEventType.h>
#include <MuQt6/QResizeEventType.h>
#include <MuQt6/QWheelEventType.h>
#include <MuQt6/QShowEventType.h>
#include <MuQt6/QDragLeaveEventType.h>
#include <MuQt6/QHideEventType.h>
#include <MuQt6/QDragEnterEventType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QDialog::~MuQt_QDialog()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QDialog::MuQt_QDialog(Pointer muobj, const CallEnvironment* ce,
                               QWidget* parent, Qt::WindowFlags f)
        : QDialog(parent, f)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QDialogType>(
            c->internName("qt.QDialog"));
    }

    QSize MuQt_QDialog::minimumSizeHint() const
    {
        if (!_env)
            return QDialog::minimumSizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QDialog::minimumSizeHint();
        }
    }

    void MuQt_QDialog::setVisible(bool visible)
    {
        if (!_env)
        {
            QDialog::setVisible(visible);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(visible);
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::setVisible(visible);
        }
    }

    QSize MuQt_QDialog::sizeHint() const
    {
        if (!_env)
            return QDialog::sizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QDialog::sizeHint();
        }
    }

    void MuQt_QDialog::closeEvent(QCloseEvent* e)
    {
        if (!_env)
        {
            QDialog::closeEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QCloseEventType>(c, e, "qt.QCloseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::closeEvent(e);
        }
    }

    void MuQt_QDialog::contextMenuEvent(QContextMenuEvent* e)
    {
        if (!_env)
        {
            QDialog::contextMenuEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[4];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QContextMenuEventType>(
                c, e, "qt.QContextMenuEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::contextMenuEvent(e);
        }
    }

    bool MuQt_QDialog::eventFilter(QObject* o, QEvent* e)
    {
        if (!_env)
            return QDialog::eventFilter(o, e);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[5];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeinstance<QObjectType>(c, o, "qt.QObject"));
            args[2] = Value(makeqpointer<QEventType>(c, e, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QDialog::eventFilter(o, e);
        }
    }

    void MuQt_QDialog::keyPressEvent(QKeyEvent* e)
    {
        if (!_env)
        {
            QDialog::keyPressEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[6];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QKeyEventType>(c, e, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::keyPressEvent(e);
        }
    }

    void MuQt_QDialog::resizeEvent(QResizeEvent* _p15)
    {
        if (!_env)
        {
            QDialog::resizeEvent(_p15);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[7];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QResizeEventType>(c, _p15, "qt.QResizeEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::resizeEvent(_p15);
        }
    }

    void MuQt_QDialog::showEvent(QShowEvent* event)
    {
        if (!_env)
        {
            QDialog::showEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[8];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QShowEventType>(c, event, "qt.QShowEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::showEvent(event);
        }
    }

    bool MuQt_QDialog::hasHeightForWidth() const
    {
        if (!_env)
            return QDialog::hasHeightForWidth();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[9];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QDialog::hasHeightForWidth();
        }
    }

    int MuQt_QDialog::heightForWidth(int w) const
    {
        if (!_env)
            return QDialog::heightForWidth(w);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[10];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(w);
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QDialog::heightForWidth(w);
        }
    }

    QVariant MuQt_QDialog::inputMethodQuery(Qt::InputMethodQuery query) const
    {
        if (!_env)
            return QDialog::inputMethodQuery(query);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[11];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(query));
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QDialog::inputMethodQuery(query);
        }
    }

    void MuQt_QDialog::changeEvent(QEvent* event)
    {
        if (!_env)
        {
            QDialog::changeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[12];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::changeEvent(event);
        }
    }

    void MuQt_QDialog::dragEnterEvent(QDragEnterEvent* event)
    {
        if (!_env)
        {
            QDialog::dragEnterEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[13];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragEnterEventType>(
                c, event, "qt.QDragEnterEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::dragEnterEvent(event);
        }
    }

    void MuQt_QDialog::dragLeaveEvent(QDragLeaveEvent* event)
    {
        if (!_env)
        {
            QDialog::dragLeaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[14];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragLeaveEventType>(
                c, event, "qt.QDragLeaveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::dragLeaveEvent(event);
        }
    }

    void MuQt_QDialog::dragMoveEvent(QDragMoveEvent* event)
    {
        if (!_env)
        {
            QDialog::dragMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[15];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragMoveEventType>(
                c, event, "qt.QDragMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::dragMoveEvent(event);
        }
    }

    void MuQt_QDialog::dropEvent(QDropEvent* event)
    {
        if (!_env)
        {
            QDialog::dropEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[16];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QDropEventType>(c, event, "qt.QDropEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::dropEvent(event);
        }
    }

    void MuQt_QDialog::focusInEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QDialog::focusInEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[17];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::focusInEvent(event);
        }
    }

    bool MuQt_QDialog::focusNextPrevChild(bool next)
    {
        if (!_env)
            return QDialog::focusNextPrevChild(next);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[18];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(next);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QDialog::focusNextPrevChild(next);
        }
    }

    void MuQt_QDialog::focusOutEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QDialog::focusOutEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[19];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::focusOutEvent(event);
        }
    }

    void MuQt_QDialog::hideEvent(QHideEvent* event)
    {
        if (!_env)
        {
            QDialog::hideEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[20];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QHideEventType>(c, event, "qt.QHideEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::hideEvent(event);
        }
    }

    void MuQt_QDialog::keyReleaseEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QDialog::keyReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[21];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::keyReleaseEvent(event);
        }
    }

    void MuQt_QDialog::leaveEvent(QEvent* event)
    {
        if (!_env)
        {
            QDialog::leaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[22];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::leaveEvent(event);
        }
    }

    void MuQt_QDialog::mouseDoubleClickEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QDialog::mouseDoubleClickEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[23];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::mouseDoubleClickEvent(event);
        }
    }

    void MuQt_QDialog::mouseMoveEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QDialog::mouseMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[24];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::mouseMoveEvent(event);
        }
    }

    void MuQt_QDialog::mousePressEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QDialog::mousePressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[25];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::mousePressEvent(event);
        }
    }

    void MuQt_QDialog::mouseReleaseEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QDialog::mouseReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[26];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::mouseReleaseEvent(event);
        }
    }

    void MuQt_QDialog::moveEvent(QMoveEvent* event)
    {
        if (!_env)
        {
            QDialog::moveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[27];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMoveEventType>(c, event, "qt.QMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::moveEvent(event);
        }
    }

    void MuQt_QDialog::paintEvent(QPaintEvent* event)
    {
        if (!_env)
        {
            QDialog::paintEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[28];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QPaintEventType>(c, event, "qt.QPaintEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::paintEvent(event);
        }
    }

    void MuQt_QDialog::tabletEvent(QTabletEvent* event)
    {
        if (!_env)
        {
            QDialog::tabletEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[29];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QTabletEventType>(c, event, "qt.QTabletEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::tabletEvent(event);
        }
    }

    void MuQt_QDialog::wheelEvent(QWheelEvent* event)
    {
        if (!_env)
        {
            QDialog::wheelEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[30];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QWheelEventType>(c, event, "qt.QWheelEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDialog::wheelEvent(event);
        }
    }

    bool MuQt_QDialog::event(QEvent* event_)
    {
        if (!_env)
            return QDialog::event(event_);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[31];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event_, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QDialog::event(event_);
        }
    }

    int MuQt_QDialog::metric(QPaintDevice::PaintDeviceMetric m) const
    {
        if (!_env)
            return QDialog::metric(m);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[32];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(m));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QDialog::metric(m);
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QDialogType::QDialogType(Context* c, const char* name, Class* super,
                             Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QDialogType::~QDialogType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer QDialog_QDialog_QObject(Thread& NODE_THREAD, Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QDialog* w = object<QDialog>(widget))
        {
            QDialogType* type = c->findSymbolOfTypeByQualifiedName<QDialogType>(
                c->internName("qt.QDialog"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(QDialog_QDialog_QObject(NODE_THREAD, NODE_ARG(0, Pointer)));
    }

    Pointer qt_QDialog_QDialog_QDialog_QDialog_QWidget_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent,
        int param_f)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QWidget* arg1 = object<QWidget>(param_parent);
        Qt::WindowFlags arg2 = (Qt::WindowFlags)(param_f);
        setobject(param_this,
                  new MuQt_QDialog(param_this, NODE_THREAD.process()->callEnv(),
                                   arg1, arg2));
        return param_this;
    }

    int qt_QDialog_result_int_QDialog(Mu::Thread& NODE_THREAD,
                                      Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        return arg0->result();
    }

    void qt_QDialog_setResult_void_QDialog_int(Mu::Thread& NODE_THREAD,
                                               Pointer param_this, int param_i)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        int arg1 = (int)(param_i);
        arg0->setResult(arg1);
    }

    Pointer qt_QDialog_minimumSizeHint_QSize_QDialog(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QDialog::minimumSizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->minimumSizeHint(),
                                          "qt.QSize");
    }

    void qt_QDialog_setVisible_void_QDialog_bool(Mu::Thread& NODE_THREAD,
                                                 Pointer param_this,
                                                 bool param_visible)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        bool arg1 = (bool)(param_visible);
        if (isMuQtObject(arg0))
            arg0->QDialog::setVisible(arg1);
        else
            arg0->setVisible(arg1);
    }

    Pointer qt_QDialog_sizeHint_QSize_QDialog(Mu::Thread& NODE_THREAD,
                                              Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QDialog::sizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->sizeHint(), "qt.QSize");
    }

    void qt_QDialog_closeEvent_void_QDialog_QCloseEvent(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QCloseEvent* arg1 = getqpointer<QCloseEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->closeEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->closeEvent_pub(arg1);
    }

    void qt_QDialog_contextMenuEvent_void_QDialog_QContextMenuEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QContextMenuEvent* arg1 = getqpointer<QContextMenuEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->contextMenuEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->contextMenuEvent_pub(arg1);
    }

    bool qt_QDialog_eventFilter_bool_QDialog_QObject_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_o,
        Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QObject* arg1 = object<QObject>(param_o);
        QEvent* arg2 = getqpointer<QEventType>(param_e);
        return isMuQtObject(arg0)
                   ? ((MuQt_QDialog*)arg0)->eventFilter_pub_parent(arg1, arg2)
                   : ((MuQt_QDialog*)arg0)->eventFilter_pub(arg1, arg2);
    }

    void qt_QDialog_keyPressEvent_void_QDialog_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->keyPressEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->keyPressEvent_pub(arg1);
    }

    void qt_QDialog_resizeEvent_void_QDialog_QResizeEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param__p15)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QResizeEvent* arg1 = getqpointer<QResizeEventType>(param__p15);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->resizeEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->resizeEvent_pub(arg1);
    }

    void qt_QDialog_showEvent_void_QDialog_QShowEvent(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this,
                                                      Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QShowEvent* arg1 = getqpointer<QShowEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->showEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->showEvent_pub(arg1);
    }

    bool qt_QDialog_hasHeightForWidth_bool_QDialog(Mu::Thread& NODE_THREAD,
                                                   Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        return isMuQtObject(arg0) ? arg0->QDialog::hasHeightForWidth()
                                  : arg0->hasHeightForWidth();
    }

    int qt_QDialog_heightForWidth_int_QDialog_int(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this,
                                                  int param_w)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        int arg1 = (int)(param_w);
        return isMuQtObject(arg0) ? arg0->QDialog::heightForWidth(arg1)
                                  : arg0->heightForWidth(arg1);
    }

    Pointer qt_QDialog_inputMethodQuery_QVariant_QDialog_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_query)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        Qt::InputMethodQuery arg1 = (Qt::InputMethodQuery)(param_query);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c, arg0->QDialog::inputMethodQuery(arg1),
                         "qt.QVariant")
                   : makeqtype<QVariantType>(c, arg0->inputMethodQuery(arg1),
                                             "qt.QVariant");
    }

    void qt_QDialog_changeEvent_void_QDialog_QEvent(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this,
                                                    Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->changeEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->changeEvent_pub(arg1);
    }

    void qt_QDialog_dragEnterEvent_void_QDialog_QDragEnterEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QDragEnterEvent* arg1 = getqpointer<QDragEnterEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->dragEnterEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->dragEnterEvent_pub(arg1);
    }

    void qt_QDialog_dragLeaveEvent_void_QDialog_QDragLeaveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QDragLeaveEvent* arg1 = getqpointer<QDragLeaveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->dragLeaveEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->dragLeaveEvent_pub(arg1);
    }

    void qt_QDialog_dragMoveEvent_void_QDialog_QDragMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QDragMoveEvent* arg1 = getqpointer<QDragMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->dragMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->dragMoveEvent_pub(arg1);
    }

    void qt_QDialog_dropEvent_void_QDialog_QDropEvent(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this,
                                                      Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QDropEvent* arg1 = getqpointer<QDropEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->dropEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->dropEvent_pub(arg1);
    }

    void qt_QDialog_focusInEvent_void_QDialog_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->focusInEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->focusInEvent_pub(arg1);
    }

    bool qt_QDialog_focusNextPrevChild_bool_QDialog_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, bool param_next)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        bool arg1 = (bool)(param_next);
        return isMuQtObject(arg0)
                   ? ((MuQt_QDialog*)arg0)->focusNextPrevChild_pub_parent(arg1)
                   : ((MuQt_QDialog*)arg0)->focusNextPrevChild_pub(arg1);
    }

    void qt_QDialog_focusOutEvent_void_QDialog_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->focusOutEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->focusOutEvent_pub(arg1);
    }

    void qt_QDialog_hideEvent_void_QDialog_QHideEvent(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this,
                                                      Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QHideEvent* arg1 = getqpointer<QHideEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->hideEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->hideEvent_pub(arg1);
    }

    void qt_QDialog_keyReleaseEvent_void_QDialog_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->keyReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->keyReleaseEvent_pub(arg1);
    }

    void qt_QDialog_leaveEvent_void_QDialog_QEvent(Mu::Thread& NODE_THREAD,
                                                   Pointer param_this,
                                                   Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->leaveEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->leaveEvent_pub(arg1);
    }

    void qt_QDialog_mouseDoubleClickEvent_void_QDialog_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->mouseDoubleClickEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->mouseDoubleClickEvent_pub(arg1);
    }

    void qt_QDialog_mouseMoveEvent_void_QDialog_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->mouseMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->mouseMoveEvent_pub(arg1);
    }

    void qt_QDialog_mousePressEvent_void_QDialog_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->mousePressEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->mousePressEvent_pub(arg1);
    }

    void qt_QDialog_mouseReleaseEvent_void_QDialog_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->mouseReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->mouseReleaseEvent_pub(arg1);
    }

    void qt_QDialog_moveEvent_void_QDialog_QMoveEvent(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this,
                                                      Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QMoveEvent* arg1 = getqpointer<QMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->moveEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->moveEvent_pub(arg1);
    }

    void qt_QDialog_paintEvent_void_QDialog_QPaintEvent(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QPaintEvent* arg1 = getqpointer<QPaintEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->paintEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->paintEvent_pub(arg1);
    }

    void qt_QDialog_tabletEvent_void_QDialog_QTabletEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QTabletEvent* arg1 = getqpointer<QTabletEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->tabletEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->tabletEvent_pub(arg1);
    }

    void qt_QDialog_wheelEvent_void_QDialog_QWheelEvent(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QWheelEvent* arg1 = getqpointer<QWheelEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDialog*)arg0)->wheelEvent_pub_parent(arg1);
        else
            ((MuQt_QDialog*)arg0)->wheelEvent_pub(arg1);
    }

    bool qt_QDialog_event_bool_QDialog_QEvent(Mu::Thread& NODE_THREAD,
                                              Pointer param_this,
                                              Pointer param_event_)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event_);
        return isMuQtObject(arg0)
                   ? ((MuQt_QDialog*)arg0)->event_pub_parent(arg1)
                   : ((MuQt_QDialog*)arg0)->event_pub(arg1);
    }

    int qt_QDialog_metric_int_QDialog_int(Mu::Thread& NODE_THREAD,
                                          Pointer param_this, int param_m)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDialog* arg0 = object<QDialog>(param_this);
        QPaintDevice::PaintDeviceMetric arg1 =
            (QPaintDevice::PaintDeviceMetric)(param_m);
        return isMuQtObject(arg0)
                   ? ((MuQt_QDialog*)arg0)->metric_pub_parent(arg1)
                   : ((MuQt_QDialog*)arg0)->metric_pub(arg1);
    }

    static NODE_IMPLEMENTATION(_n_QDialog0, Pointer)
    {
        NODE_RETURN(qt_QDialog_QDialog_QDialog_QDialog_QWidget_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int)));
    }

    static NODE_IMPLEMENTATION(_n_result0, int)
    {
        NODE_RETURN(qt_QDialog_result_int_QDialog(NODE_THREAD,
                                                  NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_setResult0, void)
    {
        qt_QDialog_setResult_void_QDialog_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int));
    }

    static NODE_IMPLEMENTATION(_n_minimumSizeHint0, Pointer)
    {
        NODE_RETURN(qt_QDialog_minimumSizeHint_QSize_QDialog(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_setVisible0, void)
    {
        qt_QDialog_setVisible_void_QDialog_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool));
    }

    static NODE_IMPLEMENTATION(_n_sizeHint0, Pointer)
    {
        NODE_RETURN(qt_QDialog_sizeHint_QSize_QDialog(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_closeEvent0, void)
    {
        qt_QDialog_closeEvent_void_QDialog_QCloseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_contextMenuEvent0, void)
    {
        qt_QDialog_contextMenuEvent_void_QDialog_QContextMenuEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_eventFilter0, bool)
    {
        NODE_RETURN(qt_QDialog_eventFilter_bool_QDialog_QObject_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_keyPressEvent0, void)
    {
        qt_QDialog_keyPressEvent_void_QDialog_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_resizeEvent0, void)
    {
        qt_QDialog_resizeEvent_void_QDialog_QResizeEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_showEvent0, void)
    {
        qt_QDialog_showEvent_void_QDialog_QShowEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hasHeightForWidth0, bool)
    {
        NODE_RETURN(qt_QDialog_hasHeightForWidth_bool_QDialog(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_heightForWidth0, int)
    {
        NODE_RETURN(qt_QDialog_heightForWidth_int_QDialog_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_inputMethodQuery0, Pointer)
    {
        NODE_RETURN(qt_QDialog_inputMethodQuery_QVariant_QDialog_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_changeEvent0, void)
    {
        qt_QDialog_changeEvent_void_QDialog_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragEnterEvent0, void)
    {
        qt_QDialog_dragEnterEvent_void_QDialog_QDragEnterEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragLeaveEvent0, void)
    {
        qt_QDialog_dragLeaveEvent_void_QDialog_QDragLeaveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragMoveEvent0, void)
    {
        qt_QDialog_dragMoveEvent_void_QDialog_QDragMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dropEvent0, void)
    {
        qt_QDialog_dropEvent_void_QDialog_QDropEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusInEvent0, void)
    {
        qt_QDialog_focusInEvent_void_QDialog_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusNextPrevChild0, bool)
    {
        NODE_RETURN(qt_QDialog_focusNextPrevChild_bool_QDialog_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool)));
    }

    static NODE_IMPLEMENTATION(_n_focusOutEvent0, void)
    {
        qt_QDialog_focusOutEvent_void_QDialog_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hideEvent0, void)
    {
        qt_QDialog_hideEvent_void_QDialog_QHideEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyReleaseEvent0, void)
    {
        qt_QDialog_keyReleaseEvent_void_QDialog_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_leaveEvent0, void)
    {
        qt_QDialog_leaveEvent_void_QDialog_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseDoubleClickEvent0, void)
    {
        qt_QDialog_mouseDoubleClickEvent_void_QDialog_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseMoveEvent0, void)
    {
        qt_QDialog_mouseMoveEvent_void_QDialog_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mousePressEvent0, void)
    {
        qt_QDialog_mousePressEvent_void_QDialog_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseReleaseEvent0, void)
    {
        qt_QDialog_mouseReleaseEvent_void_QDialog_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_moveEvent0, void)
    {
        qt_QDialog_moveEvent_void_QDialog_QMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_paintEvent0, void)
    {
        qt_QDialog_paintEvent_void_QDialog_QPaintEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_tabletEvent0, void)
    {
        qt_QDialog_tabletEvent_void_QDialog_QTabletEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_wheelEvent0, void)
    {
        qt_QDialog_wheelEvent_void_QDialog_QWheelEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QDialog_event_bool_QDialog_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_metric0, int)
    {
        NODE_RETURN(qt_QDialog_metric_int_QDialog_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    void QDialogType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QDialog_QDialog_QObject, Return, ftn,
                                Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(
                c, "QDialog", _n_QDialog0, None, Compiled,
                qt_QDialog_QDialog_QDialog_QDialog_QWidget_int, Return,
                "qt.QDialog", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "parent", "qt.QWidget"),
                new Param(c, "f", "int", Value((int)Qt::WindowFlags())), End),
            // PROP: isSizeGripEnabled (bool; QDialog this)
            new Function(c, "result", _n_result0, None, Compiled,
                         qt_QDialog_result_int_QDialog, Return, "int",
                         Parameters, new Param(c, "this", "qt.QDialog"), End),
            // PROP: setModal (void; QDialog this, bool modal)
            new Function(c, "setResult", _n_setResult0, None, Compiled,
                         qt_QDialog_setResult_void_QDialog_int, Return, "void",
                         Parameters, new Param(c, "this", "qt.QDialog"),
                         new Param(c, "i", "int"), End),
            // PROP: setSizeGripEnabled (void; QDialog this, bool _p4)
            _func[0] = new MemberFunction(
                c, "minimumSizeHint", _n_minimumSizeHint0, None, Compiled,
                qt_QDialog_minimumSizeHint_QSize_QDialog, Return, "qt.QSize",
                Parameters, new Param(c, "this", "qt.QDialog"), End),
            _func[1] = new MemberFunction(
                c, "setVisible", _n_setVisible0, None, Compiled,
                qt_QDialog_setVisible_void_QDialog_bool, Return, "void",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "visible", "bool"), End),
            _func[2] = new MemberFunction(
                c, "sizeHint", _n_sizeHint0, None, Compiled,
                qt_QDialog_sizeHint_QSize_QDialog, Return, "qt.QSize",
                Parameters, new Param(c, "this", "qt.QDialog"), End),
            _func[3] = new MemberFunction(
                c, "closeEvent", _n_closeEvent0, None, Compiled,
                qt_QDialog_closeEvent_void_QDialog_QCloseEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "e", "qt.QCloseEvent"), End),
            _func[4] = new MemberFunction(
                c, "contextMenuEvent", _n_contextMenuEvent0, None, Compiled,
                qt_QDialog_contextMenuEvent_void_QDialog_QContextMenuEvent,
                Return, "void", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "e", "qt.QContextMenuEvent"), End),
            _func[5] = new MemberFunction(
                c, "eventFilter", _n_eventFilter0, None, Compiled,
                qt_QDialog_eventFilter_bool_QDialog_QObject_QEvent, Return,
                "bool", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "o", "qt.QObject"), new Param(c, "e", "qt.QEvent"),
                End),
            _func[6] = new MemberFunction(
                c, "keyPressEvent", _n_keyPressEvent0, None, Compiled,
                qt_QDialog_keyPressEvent_void_QDialog_QKeyEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "e", "qt.QKeyEvent"), End),
            _func[7] = new MemberFunction(
                c, "resizeEvent", _n_resizeEvent0, None, Compiled,
                qt_QDialog_resizeEvent_void_QDialog_QResizeEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "_p15", "qt.QResizeEvent"), End),
            _func[8] = new MemberFunction(
                c, "showEvent", _n_showEvent0, None, Compiled,
                qt_QDialog_showEvent_void_QDialog_QShowEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QShowEvent"), End),
            _func[9] = new MemberFunction(
                c, "hasHeightForWidth", _n_hasHeightForWidth0, None, Compiled,
                qt_QDialog_hasHeightForWidth_bool_QDialog, Return, "bool",
                Parameters, new Param(c, "this", "qt.QDialog"), End),
            _func[10] = new MemberFunction(
                c, "heightForWidth", _n_heightForWidth0, None, Compiled,
                qt_QDialog_heightForWidth_int_QDialog_int, Return, "int",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "w", "int"), End),
            _func[11] = new MemberFunction(
                c, "inputMethodQuery", _n_inputMethodQuery0, None, Compiled,
                qt_QDialog_inputMethodQuery_QVariant_QDialog_int, Return,
                "qt.QVariant", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "query", "int"), End),
            // MISSING: paintEngine ("QPaintEngine *"; QDialog this)
            // MISSING: actionEvent (void; QDialog this, "QActionEvent *" event)
            // // protected
            _func[12] = new MemberFunction(
                c, "changeEvent", _n_changeEvent0, None, Compiled,
                qt_QDialog_changeEvent_void_QDialog_QEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[13] = new MemberFunction(
                c, "dragEnterEvent", _n_dragEnterEvent0, None, Compiled,
                qt_QDialog_dragEnterEvent_void_QDialog_QDragEnterEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QDragEnterEvent"), End),
            _func[14] = new MemberFunction(
                c, "dragLeaveEvent", _n_dragLeaveEvent0, None, Compiled,
                qt_QDialog_dragLeaveEvent_void_QDialog_QDragLeaveEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QDragLeaveEvent"), End),
            _func[15] = new MemberFunction(
                c, "dragMoveEvent", _n_dragMoveEvent0, None, Compiled,
                qt_QDialog_dragMoveEvent_void_QDialog_QDragMoveEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QDragMoveEvent"), End),
            _func[16] = new MemberFunction(
                c, "dropEvent", _n_dropEvent0, None, Compiled,
                qt_QDialog_dropEvent_void_QDialog_QDropEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QDropEvent"), End),
            // MISSING: enterEvent (void; QDialog this, "QEnterEvent *" event)
            // // protected
            _func[17] = new MemberFunction(
                c, "focusInEvent", _n_focusInEvent0, None, Compiled,
                qt_QDialog_focusInEvent_void_QDialog_QFocusEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[18] = new MemberFunction(
                c, "focusNextPrevChild", _n_focusNextPrevChild0, None, Compiled,
                qt_QDialog_focusNextPrevChild_bool_QDialog_bool, Return, "bool",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "next", "bool"), End),
            _func[19] = new MemberFunction(
                c, "focusOutEvent", _n_focusOutEvent0, None, Compiled,
                qt_QDialog_focusOutEvent_void_QDialog_QFocusEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[20] = new MemberFunction(
                c, "hideEvent", _n_hideEvent0, None, Compiled,
                qt_QDialog_hideEvent_void_QDialog_QHideEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QHideEvent"), End),
            // MISSING: inputMethodEvent (void; QDialog this, "QInputMethodEvent
            // *" event) // protected
            _func[21] = new MemberFunction(
                c, "keyReleaseEvent", _n_keyReleaseEvent0, None, Compiled,
                qt_QDialog_keyReleaseEvent_void_QDialog_QKeyEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[22] = new MemberFunction(
                c, "leaveEvent", _n_leaveEvent0, None, Compiled,
                qt_QDialog_leaveEvent_void_QDialog_QEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[23] = new MemberFunction(
                c, "mouseDoubleClickEvent", _n_mouseDoubleClickEvent0, None,
                Compiled,
                qt_QDialog_mouseDoubleClickEvent_void_QDialog_QMouseEvent,
                Return, "void", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[24] = new MemberFunction(
                c, "mouseMoveEvent", _n_mouseMoveEvent0, None, Compiled,
                qt_QDialog_mouseMoveEvent_void_QDialog_QMouseEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[25] = new MemberFunction(
                c, "mousePressEvent", _n_mousePressEvent0, None, Compiled,
                qt_QDialog_mousePressEvent_void_QDialog_QMouseEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[26] = new MemberFunction(
                c, "mouseReleaseEvent", _n_mouseReleaseEvent0, None, Compiled,
                qt_QDialog_mouseReleaseEvent_void_QDialog_QMouseEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[27] = new MemberFunction(
                c, "moveEvent", _n_moveEvent0, None, Compiled,
                qt_QDialog_moveEvent_void_QDialog_QMoveEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QMoveEvent"), End),
            // MISSING: nativeEvent (bool; QDialog this, QByteArray eventType,
            // "void *" message, "qintptr *" result) // protected
            _func[28] = new MemberFunction(
                c, "paintEvent", _n_paintEvent0, None, Compiled,
                qt_QDialog_paintEvent_void_QDialog_QPaintEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QPaintEvent"), End),
            _func[29] = new MemberFunction(
                c, "tabletEvent", _n_tabletEvent0, None, Compiled,
                qt_QDialog_tabletEvent_void_QDialog_QTabletEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QTabletEvent"), End),
            _func[30] = new MemberFunction(
                c, "wheelEvent", _n_wheelEvent0, None, Compiled,
                qt_QDialog_wheelEvent_void_QDialog_QWheelEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event", "qt.QWheelEvent"), End),
            _func[31] = new MemberFunction(
                c, "event", _n_event0, None, Compiled,
                qt_QDialog_event_bool_QDialog_QEvent, Return, "bool",
                Parameters, new Param(c, "this", "qt.QDialog"),
                new Param(c, "event_", "qt.QEvent"), End),
            // MISSING: initPainter (void; QDialog this, "QPainter *" painter)
            // // protected
            _func[32] = new MemberFunction(
                c, "metric", _n_metric0, None, Compiled,
                qt_QDialog_metric_int_QDialog_int, Return, "int", Parameters,
                new Param(c, "this", "qt.QDialog"), new Param(c, "m", "int"),
                End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char** propExclusions = 0;

        populate(this, QDialog::staticMetaObject, propExclusions);
    }

} // namespace Mu
