//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QListWidgetItemType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/Thread.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QSizeType.h>
#include <MuQt6/QBrushType.h>
#include <MuQt6/QIconType.h>
#include <MuQt6/QListWidgetType.h>
#include <MuQt6/QVariantType.h>
#include <MuQt6/QFontType.h>

namespace Mu
{
    using namespace std;

    QListWidgetItemType::QListWidgetItemType(Context* c, const char* name,
                                             Class* super)
        : Class(c, name, super)
    {
    }

    QListWidgetItemType::~QListWidgetItemType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    Pointer
    qt_QListWidgetItem_QListWidgetItem_QListWidgetItem_QListWidgetItem_QListWidget_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent,
        int param_type)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidget* arg1 = object<QListWidget>(param_parent);
        int arg2 = (int)(param_type);
        setqpointer<QListWidgetItemType>(param_this,
                                         new QListWidgetItem(arg1, arg2));
        return param_this;
    }

    Pointer
    qt_QListWidgetItem_QListWidgetItem_QListWidgetItem_QListWidgetItem_string_QListWidget_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_text,
        Pointer param_parent, int param_type)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        const QString arg1 = qstring(param_text);
        QListWidget* arg2 = object<QListWidget>(param_parent);
        int arg3 = (int)(param_type);
        setqpointer<QListWidgetItemType>(param_this,
                                         new QListWidgetItem(arg1, arg2, arg3));
        return param_this;
    }

    Pointer
    qt_QListWidgetItem_QListWidgetItem_QListWidgetItem_QListWidgetItem_QIcon_string_QListWidget_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_icon,
        Pointer param_text, Pointer param_parent, int param_type)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        const QIcon arg1 = getqtype<QIconType>(param_icon);
        const QString arg2 = qstring(param_text);
        QListWidget* arg3 = object<QListWidget>(param_parent);
        int arg4 = (int)(param_type);
        setqpointer<QListWidgetItemType>(
            param_this, new QListWidgetItem(arg1, arg2, arg3, arg4));
        return param_this;
    }

    Pointer qt_QListWidgetItem_background_QBrush_QListWidgetItem(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return makeqtype<QBrushType>(c, arg0->background(), "qt.QBrush");
    }

    int
    qt_QListWidgetItem_checkState_int_QListWidgetItem(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return int(arg0->checkState());
    }

    Pointer qt_QListWidgetItem_clone_QListWidgetItem_QListWidgetItem(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return makeqpointer<QListWidgetItemType>(c, arg0->clone(),
                                                 "qt.QListWidgetItem");
    }

    Pointer qt_QListWidgetItem_data_QVariant_QListWidgetItem_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_role)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        int arg1 = (int)(param_role);
        return makeqtype<QVariantType>(c, arg0->data(arg1), "qt.QVariant");
    }

    int qt_QListWidgetItem_flags_int_QListWidgetItem(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return int(arg0->flags());
    }

    Pointer
    qt_QListWidgetItem_font_QFont_QListWidgetItem(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return makeqtype<QFontType>(c, arg0->font(), "qt.QFont");
    }

    Pointer qt_QListWidgetItem_foreground_QBrush_QListWidgetItem(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return makeqtype<QBrushType>(c, arg0->foreground(), "qt.QBrush");
    }

    Pointer
    qt_QListWidgetItem_icon_QIcon_QListWidgetItem(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return makeqtype<QIconType>(c, arg0->icon(), "qt.QIcon");
    }

    bool
    qt_QListWidgetItem_isHidden_bool_QListWidgetItem(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return arg0->isHidden();
    }

    bool
    qt_QListWidgetItem_isSelected_bool_QListWidgetItem(Mu::Thread& NODE_THREAD,
                                                       Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return arg0->isSelected();
    }

    Pointer qt_QListWidgetItem_listWidget_QListWidget_QListWidgetItem(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return makeinstance<QListWidgetType>(c, arg0->listWidget(),
                                             "qt.QListWidget");
    }

    void qt_QListWidgetItem_setBackground_void_QListWidgetItem_QBrush(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_brush)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        const QBrush arg1 = getqtype<QBrushType>(param_brush);
        arg0->setBackground(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setCheckState_void_QListWidgetItem_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_state)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        Qt::CheckState arg1 = (Qt::CheckState)(param_state);
        arg0->setCheckState(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setData_void_QListWidgetItem_int_QVariant(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_role,
        Pointer param_value)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        int arg1 = (int)(param_role);
        const QVariant arg2 = getqtype<QVariantType>(param_value);
        arg0->setData(arg1, arg2);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setFlags_void_QListWidgetItem_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_flags)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        Qt::ItemFlags arg1 = (Qt::ItemFlags)(param_flags);
        arg0->setFlags(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setFont_void_QListWidgetItem_QFont(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_font)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        const QFont arg1 = getqtype<QFontType>(param_font);
        arg0->setFont(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setForeground_void_QListWidgetItem_QBrush(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_brush)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        const QBrush arg1 = getqtype<QBrushType>(param_brush);
        arg0->setForeground(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setHidden_void_QListWidgetItem_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, bool param_hide)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        bool arg1 = (bool)(param_hide);
        arg0->setHidden(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setIcon_void_QListWidgetItem_QIcon(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_icon)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        const QIcon arg1 = getqtype<QIconType>(param_icon);
        arg0->setIcon(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setSelected_void_QListWidgetItem_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, bool param_select)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        bool arg1 = (bool)(param_select);
        arg0->setSelected(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setSizeHint_void_QListWidgetItem_QSize(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_size)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        const QSize arg1 = getqtype<QSizeType>(param_size);
        arg0->setSizeHint(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setStatusTip_void_QListWidgetItem_string(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_statusTip)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        const QString arg1 = qstring(param_statusTip);
        arg0->setStatusTip(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setText_void_QListWidgetItem_string(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_text)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        const QString arg1 = qstring(param_text);
        arg0->setText(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setTextAlignment_void_QListWidgetItem_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_alignment)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        Qt::Alignment arg1 = (Qt::Alignment)(param_alignment);
        arg0->setTextAlignment(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setToolTip_void_QListWidgetItem_string(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_toolTip)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        const QString arg1 = qstring(param_toolTip);
        arg0->setToolTip(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    void qt_QListWidgetItem_setWhatsThis_void_QListWidgetItem_string(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_whatsThis)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        const QString arg1 = qstring(param_whatsThis);
        arg0->setWhatsThis(arg1);
        setqpointer<QListWidgetItemType>(param_this, arg0);
    }

    Pointer
    qt_QListWidgetItem_sizeHint_QSize_QListWidgetItem(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return makeqtype<QSizeType>(c, arg0->sizeHint(), "qt.QSize");
    }

    Pointer
    qt_QListWidgetItem_statusTip_string_QListWidgetItem(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return makestring(c, arg0->statusTip());
    }

    Pointer
    qt_QListWidgetItem_text_string_QListWidgetItem(Mu::Thread& NODE_THREAD,
                                                   Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return makestring(c, arg0->text());
    }

    int qt_QListWidgetItem_textAlignment_int_QListWidgetItem(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return arg0->textAlignment();
    }

    Pointer
    qt_QListWidgetItem_toolTip_string_QListWidgetItem(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return makestring(c, arg0->toolTip());
    }

    int qt_QListWidgetItem_type_int_QListWidgetItem(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return arg0->type();
    }

    Pointer
    qt_QListWidgetItem_whatsThis_string_QListWidgetItem(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QListWidgetItem* arg0 = getqpointer<QListWidgetItemType>(param_this);
        return makestring(c, arg0->whatsThis());
    }

    static NODE_IMPLEMENTATION(_n_QListWidgetItem0, Pointer)
    {
        NODE_RETURN(
            qt_QListWidgetItem_QListWidgetItem_QListWidgetItem_QListWidgetItem_QListWidget_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int)));
    }

    static NODE_IMPLEMENTATION(_n_QListWidgetItem1, Pointer)
    {
        NODE_RETURN(
            qt_QListWidgetItem_QListWidgetItem_QListWidgetItem_QListWidgetItem_string_QListWidget_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, Pointer), NODE_ARG(3, int)));
    }

    static NODE_IMPLEMENTATION(_n_QListWidgetItem2, Pointer)
    {
        NODE_RETURN(
            qt_QListWidgetItem_QListWidgetItem_QListWidgetItem_QListWidgetItem_QIcon_string_QListWidget_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, Pointer), NODE_ARG(3, Pointer), NODE_ARG(4, int)));
    }

    static NODE_IMPLEMENTATION(_n_background0, Pointer)
    {
        NODE_RETURN(qt_QListWidgetItem_background_QBrush_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_checkState0, int)
    {
        NODE_RETURN(qt_QListWidgetItem_checkState_int_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_clone0, Pointer)
    {
        NODE_RETURN(qt_QListWidgetItem_clone_QListWidgetItem_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_data0, Pointer)
    {
        NODE_RETURN(qt_QListWidgetItem_data_QVariant_QListWidgetItem_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_flags0, int)
    {
        NODE_RETURN(qt_QListWidgetItem_flags_int_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_font0, Pointer)
    {
        NODE_RETURN(qt_QListWidgetItem_font_QFont_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_foreground0, Pointer)
    {
        NODE_RETURN(qt_QListWidgetItem_foreground_QBrush_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_icon0, Pointer)
    {
        NODE_RETURN(qt_QListWidgetItem_icon_QIcon_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_isHidden0, bool)
    {
        NODE_RETURN(qt_QListWidgetItem_isHidden_bool_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_isSelected0, bool)
    {
        NODE_RETURN(qt_QListWidgetItem_isSelected_bool_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_listWidget0, Pointer)
    {
        NODE_RETURN(qt_QListWidgetItem_listWidget_QListWidget_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_setBackground0, void)
    {
        qt_QListWidgetItem_setBackground_void_QListWidgetItem_QBrush(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setCheckState0, void)
    {
        qt_QListWidgetItem_setCheckState_void_QListWidgetItem_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int));
    }

    static NODE_IMPLEMENTATION(_n_setData0, void)
    {
        qt_QListWidgetItem_setData_void_QListWidgetItem_int_QVariant(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setFlags0, void)
    {
        qt_QListWidgetItem_setFlags_void_QListWidgetItem_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int));
    }

    static NODE_IMPLEMENTATION(_n_setFont0, void)
    {
        qt_QListWidgetItem_setFont_void_QListWidgetItem_QFont(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setForeground0, void)
    {
        qt_QListWidgetItem_setForeground_void_QListWidgetItem_QBrush(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setHidden0, void)
    {
        qt_QListWidgetItem_setHidden_void_QListWidgetItem_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool));
    }

    static NODE_IMPLEMENTATION(_n_setIcon0, void)
    {
        qt_QListWidgetItem_setIcon_void_QListWidgetItem_QIcon(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setSelected0, void)
    {
        qt_QListWidgetItem_setSelected_void_QListWidgetItem_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool));
    }

    static NODE_IMPLEMENTATION(_n_setSizeHint0, void)
    {
        qt_QListWidgetItem_setSizeHint_void_QListWidgetItem_QSize(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setStatusTip0, void)
    {
        qt_QListWidgetItem_setStatusTip_void_QListWidgetItem_string(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setText0, void)
    {
        qt_QListWidgetItem_setText_void_QListWidgetItem_string(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setTextAlignment0, void)
    {
        qt_QListWidgetItem_setTextAlignment_void_QListWidgetItem_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int));
    }

    static NODE_IMPLEMENTATION(_n_setToolTip0, void)
    {
        qt_QListWidgetItem_setToolTip_void_QListWidgetItem_string(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setWhatsThis0, void)
    {
        qt_QListWidgetItem_setWhatsThis_void_QListWidgetItem_string(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_sizeHint0, Pointer)
    {
        NODE_RETURN(qt_QListWidgetItem_sizeHint_QSize_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_statusTip0, Pointer)
    {
        NODE_RETURN(qt_QListWidgetItem_statusTip_string_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_text0, Pointer)
    {
        NODE_RETURN(qt_QListWidgetItem_text_string_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_textAlignment0, int)
    {
        NODE_RETURN(qt_QListWidgetItem_textAlignment_int_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_toolTip0, Pointer)
    {
        NODE_RETURN(qt_QListWidgetItem_toolTip_string_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_type0, int)
    {
        NODE_RETURN(qt_QListWidgetItem_type_int_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_whatsThis0, Pointer)
    {
        NODE_RETURN(qt_QListWidgetItem_whatsThis_string_QListWidgetItem(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    void QListWidgetItemType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new MemberVariable(c, "native", "qt.NativeObject"),

                   EndArguments);

        addSymbols(new Alias(c, "ItemType", "int"),
                   new SymbolicConstant(c, "Type", "int",
                                        Value(int(QListWidgetItem::Type))),
                   new SymbolicConstant(c, "UserType", "int",
                                        Value(int(QListWidgetItem::UserType))),
                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(
                c, "QListWidgetItem", _n_QListWidgetItem0, None, Compiled,
                qt_QListWidgetItem_QListWidgetItem_QListWidgetItem_QListWidgetItem_QListWidget_int,
                Return, "qt.QListWidgetItem", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "parent", "qt.QListWidget"),
                new Param(c, "type", "int", Value((int)QListWidgetItem::Type)),
                End),
            new Function(
                c, "QListWidgetItem", _n_QListWidgetItem1, None, Compiled,
                qt_QListWidgetItem_QListWidgetItem_QListWidgetItem_QListWidgetItem_string_QListWidget_int,
                Return, "qt.QListWidgetItem", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "text", "string"),
                new Param(c, "parent", "qt.QListWidget"),
                new Param(c, "type", "int", Value((int)QListWidgetItem::Type)),
                End),
            new Function(
                c, "QListWidgetItem", _n_QListWidgetItem2, None, Compiled,
                qt_QListWidgetItem_QListWidgetItem_QListWidgetItem_QListWidgetItem_QIcon_string_QListWidget_int,
                Return, "qt.QListWidgetItem", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "icon", "qt.QIcon"),
                new Param(c, "text", "string"),
                new Param(c, "parent", "qt.QListWidget"),
                new Param(c, "type", "int", Value((int)QListWidgetItem::Type)),
                End),
            // MISSING: QListWidgetItem (QListWidgetItem; QListWidgetItem this,
            // QListWidgetItem other)
            new Function(c, "background", _n_background0, None, Compiled,
                         qt_QListWidgetItem_background_QBrush_QListWidgetItem,
                         Return, "qt.QBrush", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new Function(c, "checkState", _n_checkState0, None, Compiled,
                         qt_QListWidgetItem_checkState_int_QListWidgetItem,
                         Return, "int", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new MemberFunction(
                c, "clone", _n_clone0, None, Compiled,
                qt_QListWidgetItem_clone_QListWidgetItem_QListWidgetItem,
                Return, "qt.QListWidgetItem", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"), End),
            new MemberFunction(
                c, "data", _n_data0, None, Compiled,
                qt_QListWidgetItem_data_QVariant_QListWidgetItem_int, Return,
                "qt.QVariant", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "role", "int"), End),
            new Function(c, "flags", _n_flags0, None, Compiled,
                         qt_QListWidgetItem_flags_int_QListWidgetItem, Return,
                         "int", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new Function(c, "font", _n_font0, None, Compiled,
                         qt_QListWidgetItem_font_QFont_QListWidgetItem, Return,
                         "qt.QFont", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new Function(c, "foreground", _n_foreground0, None, Compiled,
                         qt_QListWidgetItem_foreground_QBrush_QListWidgetItem,
                         Return, "qt.QBrush", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new Function(c, "icon", _n_icon0, None, Compiled,
                         qt_QListWidgetItem_icon_QIcon_QListWidgetItem, Return,
                         "qt.QIcon", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new Function(c, "isHidden", _n_isHidden0, None, Compiled,
                         qt_QListWidgetItem_isHidden_bool_QListWidgetItem,
                         Return, "bool", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new Function(c, "isSelected", _n_isSelected0, None, Compiled,
                         qt_QListWidgetItem_isSelected_bool_QListWidgetItem,
                         Return, "bool", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new Function(
                c, "listWidget", _n_listWidget0, None, Compiled,
                qt_QListWidgetItem_listWidget_QListWidget_QListWidgetItem,
                Return, "qt.QListWidget", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"), End),
            // MISSING: read (void; QListWidgetItem this, "QDataStream &" in)
            new Function(
                c, "setBackground", _n_setBackground0, None, Compiled,
                qt_QListWidgetItem_setBackground_void_QListWidgetItem_QBrush,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "brush", "qt.QBrush"), End),
            new Function(
                c, "setCheckState", _n_setCheckState0, None, Compiled,
                qt_QListWidgetItem_setCheckState_void_QListWidgetItem_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "state", "int"), End),
            new MemberFunction(
                c, "setData", _n_setData0, None, Compiled,
                qt_QListWidgetItem_setData_void_QListWidgetItem_int_QVariant,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "role", "int"),
                new Param(c, "value", "qt.QVariant"), End),
            new Function(c, "setFlags", _n_setFlags0, None, Compiled,
                         qt_QListWidgetItem_setFlags_void_QListWidgetItem_int,
                         Return, "void", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"),
                         new Param(c, "flags", "int"), End),
            new Function(c, "setFont", _n_setFont0, None, Compiled,
                         qt_QListWidgetItem_setFont_void_QListWidgetItem_QFont,
                         Return, "void", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"),
                         new Param(c, "font", "qt.QFont"), End),
            new Function(
                c, "setForeground", _n_setForeground0, None, Compiled,
                qt_QListWidgetItem_setForeground_void_QListWidgetItem_QBrush,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "brush", "qt.QBrush"), End),
            new Function(c, "setHidden", _n_setHidden0, None, Compiled,
                         qt_QListWidgetItem_setHidden_void_QListWidgetItem_bool,
                         Return, "void", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"),
                         new Param(c, "hide", "bool"), End),
            new Function(c, "setIcon", _n_setIcon0, None, Compiled,
                         qt_QListWidgetItem_setIcon_void_QListWidgetItem_QIcon,
                         Return, "void", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"),
                         new Param(c, "icon", "qt.QIcon"), End),
            new Function(
                c, "setSelected", _n_setSelected0, None, Compiled,
                qt_QListWidgetItem_setSelected_void_QListWidgetItem_bool,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "select", "bool"), End),
            new Function(
                c, "setSizeHint", _n_setSizeHint0, None, Compiled,
                qt_QListWidgetItem_setSizeHint_void_QListWidgetItem_QSize,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "size", "qt.QSize"), End),
            new Function(
                c, "setStatusTip", _n_setStatusTip0, None, Compiled,
                qt_QListWidgetItem_setStatusTip_void_QListWidgetItem_string,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "statusTip", "string"), End),
            new Function(c, "setText", _n_setText0, None, Compiled,
                         qt_QListWidgetItem_setText_void_QListWidgetItem_string,
                         Return, "void", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"),
                         new Param(c, "text", "string"), End),
            new Function(
                c, "setTextAlignment", _n_setTextAlignment0, None, Compiled,
                qt_QListWidgetItem_setTextAlignment_void_QListWidgetItem_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "alignment", "int"), End),
            new Function(
                c, "setToolTip", _n_setToolTip0, None, Compiled,
                qt_QListWidgetItem_setToolTip_void_QListWidgetItem_string,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "toolTip", "string"), End),
            new Function(
                c, "setWhatsThis", _n_setWhatsThis0, None, Compiled,
                qt_QListWidgetItem_setWhatsThis_void_QListWidgetItem_string,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QListWidgetItem"),
                new Param(c, "whatsThis", "string"), End),
            new Function(c, "sizeHint", _n_sizeHint0, None, Compiled,
                         qt_QListWidgetItem_sizeHint_QSize_QListWidgetItem,
                         Return, "qt.QSize", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new Function(c, "statusTip", _n_statusTip0, None, Compiled,
                         qt_QListWidgetItem_statusTip_string_QListWidgetItem,
                         Return, "string", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new Function(c, "text", _n_text0, None, Compiled,
                         qt_QListWidgetItem_text_string_QListWidgetItem, Return,
                         "string", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new Function(c, "textAlignment", _n_textAlignment0, None, Compiled,
                         qt_QListWidgetItem_textAlignment_int_QListWidgetItem,
                         Return, "int", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new Function(c, "toolTip", _n_toolTip0, None, Compiled,
                         qt_QListWidgetItem_toolTip_string_QListWidgetItem,
                         Return, "string", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new Function(c, "type", _n_type0, None, Compiled,
                         qt_QListWidgetItem_type_int_QListWidgetItem, Return,
                         "int", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            new Function(c, "whatsThis", _n_whatsThis0, None, Compiled,
                         qt_QListWidgetItem_whatsThis_string_QListWidgetItem,
                         Return, "string", Parameters,
                         new Param(c, "this", "qt.QListWidgetItem"), End),
            // MISSING: write (void; QListWidgetItem this, "QDataStream &" out)
            // static functions
            EndArguments);
        globalScope()->addSymbols(
            // MISSING: = (QListWidgetItem; QListWidgetItem this,
            // QListWidgetItem other)
            EndArguments);
        scope()->addSymbols(EndArguments);

        //
        // Copyright (C) 2023  Autodesk, Inc. All Rights Reserved.
        //
        // SPDX-License-Identifier: Apache-2.0
        //

        c->arrayType(this, 1, 0);
    }

} // namespace Mu
