//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QMoveEventType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/Thread.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QPointType.h>

namespace Mu
{
    using namespace std;

    QMoveEventType::QMoveEventType(Context* c, const char* name, Class* super)
        : Class(c, name, super)
    {
    }

    QMoveEventType::~QMoveEventType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    Pointer qt_QMoveEvent_QMoveEvent_QMoveEvent_QMoveEvent_QPoint_QPoint(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_pos,
        Pointer param_oldPos)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        const QPoint arg1 = getqtype<QPointType>(param_pos);
        const QPoint arg2 = getqtype<QPointType>(param_oldPos);
        setqpointer<QMoveEventType>(param_this, new QMoveEvent(arg1, arg2));
        return param_this;
    }

    Pointer qt_QMoveEvent_oldPos_QPoint_QMoveEvent(Mu::Thread& NODE_THREAD,
                                                   Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMoveEvent* arg0 = getqpointer<QMoveEventType>(param_this);
        return makeqtype<QPointType>(c, arg0->oldPos(), "qt.QPoint");
    }

    Pointer qt_QMoveEvent_pos_QPoint_QMoveEvent(Mu::Thread& NODE_THREAD,
                                                Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMoveEvent* arg0 = getqpointer<QMoveEventType>(param_this);
        return makeqtype<QPointType>(c, arg0->pos(), "qt.QPoint");
    }

    static NODE_IMPLEMENTATION(_n_QMoveEvent0, Pointer)
    {
        NODE_RETURN(
            qt_QMoveEvent_QMoveEvent_QMoveEvent_QMoveEvent_QPoint_QPoint(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_oldPos0, Pointer)
    {
        NODE_RETURN(qt_QMoveEvent_oldPos_QPoint_QMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_pos0, Pointer)
    {
        NODE_RETURN(qt_QMoveEvent_pos_QPoint_QMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    void QMoveEventType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new MemberVariable(c, "native", "qt.NativeObject"),

                   EndArguments);

        addSymbols(EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(
                c, "QMoveEvent", _n_QMoveEvent0, None, Compiled,
                qt_QMoveEvent_QMoveEvent_QMoveEvent_QMoveEvent_QPoint_QPoint,
                Return, "qt.QMoveEvent", Parameters,
                new Param(c, "this", "qt.QMoveEvent"),
                new Param(c, "pos", "qt.QPoint"),
                new Param(c, "oldPos", "qt.QPoint"), End),
            new Function(c, "oldPos", _n_oldPos0, None, Compiled,
                         qt_QMoveEvent_oldPos_QPoint_QMoveEvent, Return,
                         "qt.QPoint", Parameters,
                         new Param(c, "this", "qt.QMoveEvent"), End),
            new Function(c, "pos", _n_pos0, None, Compiled,
                         qt_QMoveEvent_pos_QPoint_QMoveEvent, Return,
                         "qt.QPoint", Parameters,
                         new Param(c, "this", "qt.QMoveEvent"), End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);
    }

} // namespace Mu
